//---------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#ifndef DispFormH
#define DispFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <Grids.hpp>
//
#include "MACCAPV2Lib_TLB.h"
#include <Dialogs.hpp>
#include <Menus.hpp>

class TSearchDlg;
class TCapForm;
typedef int (TCapForm::* SearchFunc)(int, int, AnsiString&, int&);

//---------------------------------------------------------------------------
class TCapForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TPanel *Panel1;
    TPanel *Panel2;
    TToolBar *ToolBar1;
    TImageList *ImageList;
    TToolButton *ToolButtonSave;
    TActionList *ActionList;
    TStatusBar *StatusBar;
    TToolButton *ToolButton1;
    TToolButton *ToolButtonCopy;
    TSplitter *Splitter1;
    TToolButton *ToolButton2;
    TToolButton *ToolButtonFont;
    TToolButton *ToolButton3;
    TToolButton *ToolButtonUp;
    TToolButton *ToolButtonDown;
    TToolButton *ToolButton6;
    TToolButton *ToolButtonExit;
    TAction *ActionClose;
    TListView *ListView;
    TRichEdit *DataView;
    TAction *ActionUp;
    TAction *ActionDown;
    TAction *ActionCopy;
    TAction *ActionFont;
    TFontDialog *FontDialog;
    TToolButton *ToolButtonFind;
    TAction *ActionFind;
    TToolButton *ToolButton4;
    TAction *ActionDescription;
    TToolButton *ToolButtonDesc;
    TToolButton *ToolButton7;
    TToolButton *ToolButton8;
    TAction *ActionFileSave;
    TSaveDialog *SaveDialog;
    TToolButton *ToolButtonNext;
    TAction *ActionFindNext;
    TPopupMenu *PopupMenu;
    TMenuItem *A1;
    TMenuItem *Print1;
    TMenuItem *N2;
    TMenuItem *Copy1;
    TPopupMenu *ListPopupMenu;
    TMenuItem *Find1;
    TMenuItem *FindNext1;
    TMenuItem *N3;
    TAction *ActionSelFileSave;
    TAction *ActionUncheck;
    TMenuItem *ActionSelFileSave1;
    TMenuItem *N4;
    TMenuItem *D1;
    TMenuItem *N5;
    TAction *ActionSelConnection;
    TMenuItem *N6;
    TAction *ActionSaveThis;
    TToolButton *ToolButton5;
    TAction *ActionUpChecked;
    TAction *ActionDownChecked;
    TToolButton *ToolButton9;
    TToolButton *ToolButton10;
    TAction *ActionPrintThis;
    TAction *ActionSelectAll;
    TMenuItem *SelectAll1;
    TMenuItem *N1;
    TMenuItem *MenuN4;
    TMenuItem *MenuN5;
    TMenuItem *MenuN6;
    TMenuItem *MenuN7;
    TMenuItem *MenuN8;
    TMenuItem *MenuN9;
    TMenuItem *MenuN10;
    TAction *ActionChangeWidth;
    TMenuItem *MenuN11;
    TAction *ActionDescAll;
    TMenuItem *D2;
    TToolButton *ToolButton11;
    void __fastcall ActionCloseExecute(TObject *Sender);
    void __fastcall Panel1DockDrop(TObject *Sender,
          TDragDockObject *Source, int X, int Y);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall ActionDownExecute(TObject *Sender);
    void __fastcall ActionUpExecute(TObject *Sender);
    void __fastcall ListViewSelectItem(TObject *Sender, TListItem *Item,
          bool Selected);
    void __fastcall ActionUpUpdate(TObject *Sender);
    void __fastcall ActionDownUpdate(TObject *Sender);
    void __fastcall ActionCopyUpdate(TObject *Sender);
    void __fastcall ActionCopyExecute(TObject *Sender);
    void __fastcall ActionFontExecute(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall FormDeactivate(TObject *Sender);
    void __fastcall ActionFileSaveExecute(TObject *Sender);
    void __fastcall ActionFindExecute(TObject *Sender);
    void __fastcall ActionFindNextExecute(TObject *Sender);
    void __fastcall ActionFindNextUpdate(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall ActionSelFileSaveExecute(TObject *Sender);
    void __fastcall ActionUncheckExecute(TObject *Sender);
    void __fastcall ActionSelConnectionUpdate(TObject *Sender);
    void __fastcall ActionSaveThisExecute(TObject *Sender);
    void __fastcall ActionUpCheckedExecute(TObject *Sender);
    void __fastcall ActionDownCheckedExecute(TObject *Sender);
    void __fastcall ActionPrintThisExecute(TObject *Sender);
    void __fastcall ActionSelectAllExecute(TObject *Sender);
    void __fastcall ActionChangeWidthExecute(TObject *Sender);
    void __fastcall ActionDescriptionExecute(TObject *Sender);
    void __fastcall ActionDescriptionUpdate(TObject *Sender);
    void __fastcall ActionDescAllExecute(TObject *Sender);
    void __fastcall ActionSelConnectionExecute(TObject *Sender);
private:	// [U[錾
    int ToolBarHeight;
    int DumpWidth;
    long cbCaps;
    AnsiString FileName;
    TFont* DataFont;
    void __fastcall ChangeFT(__int64& ft, SYSTEMTIME& st);
    void __fastcall PrintDump(int n, int seloffset = 0, int sellength = 0);
    void __fastcall PrintDump(TStrings*, IRawMacPacket*, int seloffset = 0, int sellength = 0);
    void __fastcall PrintDump(TListItem*);
    void __fastcall RowMove(TSearchDirection);
    void __fastcall DumpData(LPBYTE pb, int len, int offset, TStrings*, int, int, int&);
    void __fastcall DumpData(LPBYTE pb, int len, int offset, TStrings*);
    void __fastcall ShowHint(TObject *Sender);
    void __fastcall ShowIndex(int);
    // Search Function Info.
    int nStart;
    AnsiString target;
    SearchFunc pFunc;
    bool NoUpdate;
    int SearchItemTime(int, int, AnsiString&, int& col);
    int SearchItemIP(int, int, AnsiString&, int& col);
    int SearchData(int, int, AnsiString&, int& col);
    void PrintSearchedItem();
    void __fastcall SaveText(TFileStream*, TStrings*, bool);
    void __fastcall SaveCSV(TFileStream*, bool);
    AnsiString __fastcall Pack(AnsiString& s);
    AnsiString __fastcall GetTextTitle(TListItem*);
    void __fastcall RowMoveChecked(TSearchDirection);
    bool __fastcall GetTcpInfo(TListItem*, DWORD&, DWORD&, WORD&, WORD&, DWORD&, DWORD&);
    void __fastcall CheckConnection(int, DWORD, DWORD, WORD, WORD, DWORD, DWORD, bool up);
public:		// [U[錾
	enum {
        DEF_WIDTH = 8,
        //
		MAC_HLEN = 14,
		//
		ET_RARP = 0x8035,
	};
    __fastcall TCapForm(TComponent* Owner);
    void __fastcall SetPackets(IPacketCollectionPtr, TProgressBar*);
    inline void SetFileName(AnsiString& s)
    {
        FileName = s;
        Caption = "FreePeek - " + s;
    }
};
//---------------------------------------------------------------------------
extern PACKAGE TCapForm *CapForm;
//---------------------------------------------------------------------------
#endif
