//---------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#include <vcl.h>
#pragma hdrstop

#include "PacketType.h"
#include "FreePeekStrs.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TPacketTypeDlg *PacketTypeDlg;
//---------------------------------------------------------------------
__fastcall TPacketTypeDlg::TPacketTypeDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------

void __fastcall TPacketTypeDlg::CancelBtnClick(TObject *Sender)
{
    ModalResult = IDCANCEL;
}
//---------------------------------------------------------------------------
void __fastcall TPacketTypeDlg::FormShow(TObject *Sender)
{
    ResultString = "";
    ResultValue = -1;
}
//---------------------------------------------------------------------------
void __fastcall TPacketTypeDlg::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
	if (ModalResult == mrOk)
	{
        int sel = List->ItemIndex;
        if (sel >= 0)
        {
            ResultString = List->Items->Strings[sel];
            ResultValue = reinterpret_cast<int>(List->Items->Objects[sel]);
            CanClose = true;
        }
        else
        {
			MessageDlg(LoadStr(rsNoSelection), mtError, TMsgDlgButtons() << mbOK, 0);
            CanClose = false;
        }
    }
}
//---------------------------------------------------------------------------

