// copyright(c) 1999 arton
#ifndef PORT_ASSNUM
#define PORT_ASSNUM

inline WORD ntohs(LPBYTE pb) { return (WORD)((*pb << 8) | *(pb + 1)); }
inline DWORD ntohl(LPBYTE pb) { return (DWORD)((*pb << 24) | (*(pb + 1) << 16) | (*(pb + 2) << 8) | *(pb + 3)); }


#ifndef COUNTOF
#define COUNTOF(x) (sizeof(x)/sizeof(x[0]))
#endif

class AssPort {
public:
    static void FillString(TStringList*& pList, bool tcp);
    static const char* SearchTCPPort(int);
    static const char* SearchUDPPort(int);
private:
    static const char* SearchPort(int port, bool tcp);
    struct SAssPort {
      const char* ServiceName;
      int   Port;
    };
    static SAssPort udpPort[];
    static SAssPort tcpPort[];
};

#endif

