//----------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#ifndef ValOffsetH
#define ValOffsetH
//----------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <Grids.hpp>
//----------------------------------------------------------------------------
#ifndef COUNTOF
#define COUNTOF(x) (sizeof(x)/sizeof(x[0]))
#endif

class TValOffsetDlg : public TForm
{
__published:
	TButton *OKBtn;
	TButton *CancelBtn;
	TBevel *Bevel1;
    TComboBox *ComboOffset;
    TLabel *Label1;
    TLabel *Label2;
    TEdit *EditValue;
    TLabel *Label3;
    TEdit *EditOffset;
    TButton *ButtonExpand;
    TStringGrid *CodeGrid;
    TComboBox *ComboCode;
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall ButtonExpandClick(TObject *Sender);
    void __fastcall ComboCodeChange(TObject *Sender);
    void __fastcall CodeGridDblClick(TObject *Sender);
private:
    int offsetValue;
    AnsiString DataValue;
    void SetCodes(int);
public:
    enum {
        SHRINKED_HEIGHT = 128,
        EXPANDED_HEIGHT = 450,
    };
	virtual __fastcall TValOffsetDlg(TComponent* AOwner);
    inline int GetOffset() const { return offsetValue; }
    inline AnsiString& GetData() { return DataValue; }
    enum {
        MAX_DATALEN = 64,
    };
};
//----------------------------------------------------------------------------
extern PACKAGE TValOffsetDlg *ValOffsetDlg;
//----------------------------------------------------------------------------
#endif    
