//----------------------------------------------------------------------------
// Copyright(c) 1999 arton
//
#ifndef IPFiltersettingH
#define IPFiltersettingH
//----------------------------------------------------------------------------
#include <vcl\System.hpp>
#include <vcl\Windows.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include "MACCAPV2Lib_TLB.h"
//----------------------------------------------------------------------------
class TIPFilterDlg : public TForm
{
__published:
	TButton *OKBtn;
	TButton *CancelBtn;
    TTabControl *TabControl;
    TComboBox *ComboBox;
    TRadioGroup *DestinationGroup;
    void __fastcall TabControlChange(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
private:
    TStringList* listProtocol;
    TStringList* listTCP;
    TStringList* listUDP;
    void SetDirection(bool);
    int result;
    int direction;
    _FilterTypeConstants ftype;
    AnsiString resultString;
public:
	virtual __fastcall TIPFilterDlg(TComponent* AOwner);
    inline void SetProtocolList(TStringList* p) { listProtocol = p; }
    inline void SetTCPList(TStringList* p) { listTCP = p; }
    inline void SetUDPList(TStringList* p) { listUDP = p; }
    inline _FilterTypeConstants GetFilterType() const { return ftype; }
    inline int GetResult() const { return result; }
    inline AnsiString& GetResultString() { return resultString; }
    inline int GetDirection() const { return direction; }
};
//----------------------------------------------------------------------------
extern PACKAGE TIPFilterDlg *IPFilterDlg;
//----------------------------------------------------------------------------
#endif
