// Copyright(c) 1999 arton
#include <vcl.h>
#pragma hdrstop
#include "PortAssNum.h"

AssPort::SAssPort AssPort::udpPort[] = {
    { "tcpmux", 1 /*     TCP Port Service Multiplexer */ },
    { "compressnet", 2 /*     Management Utility */ },
    { "compressnet", 3 /*     Compression Process */ }, 
    { "rje", 5 /*     Remote Job Entry */ }, 
    { "echo", 7 /*     Echo */ }, 
    { "discard", 9 /*     Discard */ }, 
    { "systat", 11 /*     Active Users */ }, 
    { "daytime", 13 /*     Daytime */ }, 
    { "qotd", 17 /*     Quote of the Day */ }, 
    { "msp", 18 /*     Message Send Protocol */ }, 
    { "chargen", 19 /*     Character Generator */ }, 
    { "ftp-data", 20 /*     File Transfer [Default Data] */ }, 
    { "ftp", 21 /*     File Transfer [Control] */ }, 
    { "telnet", 23 /*     Telnet */ }, 
    { "smtp", 25 /*     Simple Mail Transfer */ }, 
    { "nsw-fe", 27 /*     NSW User System FE */ }, 
    { "msg-icp", 29 /*     MSG ICP */ }, 
    { "msg-auth", 31 /*     MSG Authentication */ }, 
    { "dsp", 33 /*     Display Support Protocol */ }, 
    { "time", 37 /*     Time */ }, 
    { "rap", 38 /*     Route Access Protocol */ }, 
    { "rlp", 39 /*     Resource Location Protocol */ }, 
    { "graphics", 41 /*     Graphics */ },
    { "nameserver", 42 /*     Host Name Server */ }, 
    { "nicname", 43 /*     Who Is */ }, 
    { "mpm-flags", 44 /*     MPM FLAGS Protocol */ }, 
    { "mpm", 45 /*     Message Processing Module [recv] */ }, 
    { "mpm-snd", 46 /*     MPM [default send] */ }, 
    { "ni-ftp", 47 /*     NI FTP */ }, 
    { "auditd", 48 /*     Digital Audit Daemon */ }, 
    { "login", 49 /*     Login Host Protocol */ }, 
    { "re-mail-ck", 50 /*     Remote Mail Checking Protocol */ }, 
    { "la-maint", 51 /*     IMP Logical Address Maintenance */ }, 
    { "xns-time", 52 /*     XNS Time Protocol */ }, 
    { "domain", 53 /*     Domain Name Server */ }, 
    { "xns-ch", 54 /*     XNS Clearinghouse */ },
    { "isi-gl", 55 /*     ISI Graphics Language */ },
    { "xns-auth", 56 /*     XNS Authentication */ }, 
    { "xns-mail", 58 /*     XNS Mail */ }, 
    { "ni-mail", 61 /*     NI MAIL */ }, 
    { "acas", 62 /*     ACA Services */ }, 
    { "covia", 64 /*     Communications Integrator (CI) */ }, 
    { "tacacs-ds", 65 /*     TACACS-Database Service */ }, 
    { "sql*net", 66 /*     Oracle SQL*NET */ }, 
    { "bootps", 67 /*     Bootstrap Protocol Server */ }, 
    { "bootpc", 68 /*     Bootstrap Protocol Client */ }, 
    { "tftp", 69 /*     Trivial File Transfer */ }, 
    { "gopher", 70 /*     Gopher */ }, 
    { "netrjs-1", 71 /*     Remote Job Service */ }, 
    { "netrjs-2", 72 /*     Remote Job Service */ }, 
    { "netrjs-3", 73 /*     Remote Job Service */ }, 
    { "netrjs-4", 74 /*     Remote Job Service */ }, 
    { "deos", 76 /*     Distributed External Object Store */ }, 
    { "vettcp", 78 /*     vettcp */ }, 
    { "finger", 79 /*     Finger */ }, 
    { "www-http", 80 /*     World Wide Web HTTP */ }, 
    { "hosts2-ns", 81 /*     HOSTS2 Name Server */ }, 
    { "xfer", 82 /*     XFER Utility */ }, 
    { "mit-ml-dev", 83 /*     MIT ML Device */ }, 
    { "ctf", 84 /*     Common Trace Facility */ },
    { "mit-ml-dev", 85 /*     MIT ML Device */ }, 
    { "mfcobol", 86 /*     Micro Focus Cobol */ }, 
    { "kerberos", 88 /*     Kerberos */ }, 
    { "su-mit-tg", 89 /*     SU/MIT Telnet Gateway */ }, 
    { "dnsix", 90 /*     DNSIX Securit Attribute Token Map */ }, 
    { "mit-dov", 91 /*     MIT Dover Spooler */ }, 
    { "npp", 92 /*     Network Printing Protocol */ }, 
    { "dcp", 93 /*     Device Control Protocol */ }, 
    { "objcall", 94 /*     Tivoli Object Dispatcher */ }, 
    { "supdup", 95 /*     SUPDUP */ }, 
    { "dixie", 96 /*     DIXIE Protocol Specification */ }, 
    { "swift-rvf", 97 /*     Swift Remote Vitural File Protocol */ }, 
    { "tacnews", 98 /*     TAC News */ },
    { "metagram", 99 /*     Metagram Relay */ },
    { "hostname", 101 /*     NIC Host Name Server */ }, 
    { "iso-tsap", 102 /*     ISO-TSAP */ }, 
    { "gppitnp", 103 /*     Genesis Point-to-Point Trans Net */ }, 
    { "acr-nema", 104 /*     ACR-NEMA Digital Imag. & Comm. 300 */ }, 
    { "csnet-ns", 105 /*     Mailbox Name Nameserver */ }, 
    { "rtelnet", 107 /*     Remote Telnet Service */ }, 
    { "snagas", 108 /*     SNA Gateway Access Server */ }, 
    { "pop2", 109 /*     Post Office Protocol - Version 2 */ }, 
    { "pop3", 110 /*     Post Office Protocol - Version 3 */ }, 
    { "sunrpc", 111 /*     SUN Remote Procedure Call */ }, 
    { "mcidas", 112 /*     McIDAS Data Transmission Protocol */ }, 
    { "auth", 113 /*     Authentication Service */ }, 
    { "audionews", 114 /*     Audio News Multicast */ }, 
    { "sftp", 115 /*     Simple File Transfer Protocol */ }, 
    { "ansanotify", 116 /*     ANSA REX Notify */ }, 
    { "uucp-path", 117 /*     UUCP Path Service */ }, 
    { "sqlserv", 118 /*     SQL Services */ }, 
    { "nntp", 119 /*     Network News Transfer Protocol */ }, 
    { "cfdptkt", 120 /*     CFDPTKT */ }, 
    { "erpc", 121 /*     Encore Expedited Remote Pro.Call */ }, 
    { "smakynet", 122 /*     SMAKYNET */ }, 
    { "ntp", 123 /*     Network Time Protocol */ }, 
    { "ansatrader", 124 /*     ANSA REX Trader */ },
    { "locus-map", 125 /*     Locus PC-Interface Net Map Ser */ }, 
    { "unitary", 126 /*     Unisys Unitary Login */ }, 
    { "locus-con", 127 /*     Locus PC-Interface Conn Server */ }, 
    { "gss-xlicen", 128 /*     GSS X License Verification */ }, 
    { "pwdgen", 129 /*     Password Generator Protocol */ }, 
    { "cisco-fna", 130 /*     cisco FNATIVE */ }, 
    { "cisco-tna", 131 /*     cisco TNATIVE */ }, 
    { "cisco-sys", 132 /*     cisco SYSMAINT */ }, 
    { "statsrv", 133 /*     Statistics Service */ }, 
    { "ingres-net", 134 /*     INGRES-NET Service */ }, 
    { "loc-srv", 135 /*     Location Service */ }, 
    { "profile", 136 /*     PROFILE Naming System */ }, 
    { "netbios-ns", 137 /*     NETBIOS Name Service */ },
    { "netbios-dgm", 138 /*     NETBIOS Datagram Service */ },
    { "netbios-ssn", 139 /*     NETBIOS Session Service */ }, 
    { "emfis-data", 140 /*     EMFIS Data Service */ }, 
    { "emfis-cntl", 141 /*     EMFIS Control Service */ }, 
    { "bl-idm", 142 /*     Britton-Lee IDM */ }, 
    { "imap2", 143 /*     Interim Mail Access Protocol v2 */ }, 
    { "news", 144 /*     NewS */ }, 
    { "uaac", 145 /*     UAAC Protocol */ }, 
    { "iso-tp0", 146 /*     ISO-IP0 */ }, 
    { "iso-ip", 147 /*     ISO-IP */ }, 
    { "cronus", 148 /*     CRONUS-SUPPORT */ }, 
    { "aed-512", 149 /*     AED 512 Emulation Service */ }, 
    { "sql-net", 150 /*     SQL-NET */ }, 
    { "hems", 151 /*     HEMS */ }, 
    { "bftp", 152 /*     Background File Transfer Program */ }, 
    { "sgmp", 153 /*     SGMP */ }, 
    { "netsc-prod", 154 /*     NETSC */ }, 
    { "netsc-dev", 155 /*     NETSC */ }, 
    { "sqlsrv", 156 /*     SQL Service */ }, 
    { "knet-cmp", 157 /*     KNET/VM Command/Message Protocol */ }, 
    { "pcmail-srv", 158 /*     PCMail Server */ }, 
    { "nss-routing", 159 /*     NSS-Routing */ }, 
    { "sgmp-traps", 160 /*     SGMP-TRAPS */ }, 
    { "snmp", 161 /*     SNMP */ },
    { "snmptrap", 162 /*     SNMPTRAP */ }, 
    { "cmip-man", 163 /*     CMIP/TCP Manager */ }, 
    { "smip-agent", 164 /*     CMIP/TCP Agent */ }, 
    { "xns-courier", 165 /*     Xerox */ }, 
    { "s-net", 166 /*     Sirius Systems */ }, 
    { "namp", 167 /*     NAMP */ }, 
    { "rsvd", 168 /*     RSVD */ }, 
    { "send", 169 /*     SEND */ }, 
    { "print-srv", 170 /*     Network PostScript */ }, 
    { "multiplex", 171 /*     Network Innovations Multiplex */ }, 
    { "cl/1", 172 /*     Network Innovations CL/1 */ }, 
    { "xyplex-mux", 173 /*     Xyplex */ }, 
    { "mailq", 174 /*     MAILQ */ },
    { "vmnet", 175 /*     VMNET */ },
    { "genrad-mux", 176 /*     GENRAD-MUX */ }, 
    { "xdmcp", 177 /*     X Display Manager Control Protocol */ }, 
    { "NextStep", 178 /*     NextStep Window Server */ }, 
    { "bgp", 179 /*     Border Gateway Protocol */ }, 
    { "ris", 180 /*     Intergraph */ }, 
    { "unify", 181 /*     Unify */ }, 
    { "audit", 182 /*     Unisys Audit SITP */ }, 
    { "ocbinder", 183 /*     OCBinder */ }, 
    { "ocserver", 184 /*     OCServer */ }, 
    { "remote-kis", 185 /*     Remote-KIS */ }, 
    { "kis", 186 /*     KIS Protocol */ }, 
    { "aci", 187 /*     Application Communication Interface */ }, 
    { "mumps", 188 /*     Plus Five's MUMPS */ }, 
    { "qft", 189 /*     Queued File Transport */ }, 
    { "cacp", 190 /*     Gateway Access Control Protocol */ }, 
    { "prospero", 191 /*     Prospero Directory Service */ }, 
    { "osu-nms", 192 /*     OSU Network Monitoring System */ }, 
    { "srmp", 193 /*     Spider Remote Monitoring Protocol */ }, 
    { "irc", 194 /*     Internet Relay Chat Protocol */ }, 
    { "dn6-nlm-aud", 195 /*     DNSIX Network Level Module Audit */ }, 
    { "dn6-smm-red", 196 /*     DNSIX Session Mgt Module Audit Redir */ }, 
    { "dls", 197 /*     Directory Location Service */ }, 
    { "dls-mon", 198 /*     Directory Location Service Monitor */ },
    { "smux", 199 /*     SMUX */ }, 
    { "src", 200 /*     IBM System Resource Controller */ }, 
    { "at-rtmp", 201 /*     AppleTalk Routing Maintenance */ }, 
    { "at-nbp", 202 /*     AppleTalk Name Binding */ }, 
    { "at-3", 203 /*     AppleTalk Unused */ }, 
    { "at-echo", 204 /*     AppleTalk Echo */ }, 
    { "at-5", 205 /*     AppleTalk Unused */ }, 
    { "at-zis", 206 /*     AppleTalk Zone Information */ }, 
    { "at-7", 207 /*     AppleTalk Unused */ }, 
    { "at-8", 208 /*     AppleTalk Unused */ }, 
    { "tam", 209 /*     Trivial Authenticated Mail Protocol */ }, 
    { "z39.50", 210 /*     ANSI Z39.50 */ }, 
    { "anet", 212 /*     ATEXSSTR */ },
    { "ipx", 213 /*     IPX */ },
    { "vmpwscs", 214 /*     VM PWSCS */ }, 
    { "softpc", 215 /*     Insignia Solutions */ }, 
    { "atls", 216 /*     Access Technology License Server */ }, 
    { "dbase", 217 /*     dBASE Unix */ }, 
    { "mpp", 218 /*     Netix Message Posting Protocol */ }, 
    { "uarps", 219 /*     Unisys ARPs */ }, 
    { "imap3", 220 /*     Interactive Mail Access Protocol v3 */ }, 
    { "fln-spx", 221 /*     Berkeley rlogind with SPX auth */ }, 
    { "rsh-spx", 222 /*     Berkeley rshd with SPX auth */ }, 
    { "cdc", 223 /*     Certificate Distribution Center */ }, 
    { "sur-meas", 243 /*     Survey Measurement */ }, 
    { "link", 245 /*     LINK */ }, 
    { "dsp3270", 246 /*     Display Systems Protocol */ }, 
    { "pdap", 344 /*     Prospero Data Access Protocol */ }, 
    { "pawserv", 345 /*     Perf Analysis Workbench */ }, 
    { "zserv", 346 /*     Zebra server */ }, 
    { "fatserv", 347 /*     Fatmen Server */ }, 
    { "csi-sgwp", 348 /*     Cabletron Management Protocol */ }, 
    { "clearcase", 371 /*     Clearcase */ }, 
    { "ulistserv", 372 /*     Unix Listserv */ }, 
    { "legent-1", 373 /*     Legent Corporation */ }, 
    { "legent-2", 374 /*     Legent Corporation */ }, 
    { "hassle", 375 /*     Hassle */ },
    { "nip", 376 /*     Amiga Envoy Network Inquiry Proto */ }, 
    { "tnETOS", 377 /*     NEC Corporation */ }, 
    { "dsETOS", 378 /*     NEC Corporation */ }, 
    { "is99c", 379 /*     TIA/EIA/IS-99 modem client */ }, 
    { "is99s", 380 /*     TIA/EIA/IS-99 modem server */ }, 
    { "hp-collector", 381 /*     hp performance data collector */ }, 
    { "hp-managed-node", 382 /*     hp performance data managed node */ }, 
    { "hp-alarm-mgr", 383 /*     hp performance data alarm manager */ }, 
    { "arns", 384 /*     A Remote Network Server System */ }, 
    { "asa", 386 /*     ASA Message Router Object Def. */ }, 
    { "aurp", 387 /*     Appletalk Update-Based Routing Pro. */ }, 
    { "unidata-ldm", 388 /*     Unidata LDM Version 4 */ }, 
    { "ldap", 389 /*     Lightweight Directory Access Protocol */ },
    { "uis", 390 /*     UIS */ },
    { "synotics-relay", 391 /*     SynOptics SNMP Relay Port */ }, 
    { "synotics-broker", 392 /*     SynOptics Port Broker Port */ }, 
    { "dis", 393 /*     Data Interpretation System */ }, 
    { "embl-ndt", 394 /*     EMBL Nucleic Data Transfer */ }, 
    { "netcp", 395 /*     NETscout Control Protocol */ }, 
    { "netware-ip", 396 /*     Novell Netware over IP */ }, 
    { "mptn", 397 /*     Multi Protocol Trans. Net. */ }, 
    { "kryptolan", 398 /*     Kryptolan */ }, 
    { "work-sol", 400 /*     Workstation Solutions */ }, 
    { "ups", 401 /*     Uninterruptible Power Supply */ }, 
    { "genie", 402 /*     Genie Protocol */ }, 
    { "decap", 403 /*     decap */ }, 
    { "nced", 404 /*     nced */ }, 
    { "ncld", 405 /*     ncld */ }, 
    { "imsp", 406 /*     Interactive Mail Support Protocol */ }, 
    { "timbuktu", 407 /*     Timbuktu */ }, 
    { "prm-sm", 408 /*     Prospero Resource Manager Sys. Man. */ }, 
    { "prm-nm", 409 /*     Prospero Resource Manager Node Man. */ }, 
    { "decladebug", 410 /*     DECLadebug Remote Debug Protocol */ }, 
    { "rmt", 411 /*     Remote MT Protocol */ }, 
    { "synoptics-trap", 412 /*     Trap Convention Port */ }, 
    { "smsp", 413 /*     SMSP */ }, 
    { "infoseek", 414 /*     InfoSeek */ },
    { "bnet", 415 /*     BNet */ }, 
    { "silverplatter", 416 /*     Silverplatter */ }, 
    { "onmux", 417 /*     Onmux */ }, 
    { "hyper-g", 418 /*     Hyper-G */ }, 
    { "ariel1", 419 /*     Ariel */ }, 
    { "smpte", 420 /*     SMPTE */ }, 
    { "ariel2", 421 /*     Ariel */ }, 
    { "ariel3", 422 /*     Ariel */ }, 
    { "opc-job-start", 423 /*     IBM Operations Planning and Control Start */ }, 
    { "opc-job-track", 424 /*     IBM Operations Planning and Control Track */ }, 
    { "icad-el", 425 /*     ICAD */ }, 
    { "smartsdp", 426 /*     smartsdp */ }, 
    { "svrloc", 427 /*     Server Location */ },
    { "ocs_cmu", 428 /*     OCS_CMU */ },
    { "ocs_amu", 429 /*     OCS_AMU */ }, 
    { "utmpsd", 430 /*     UTMPSD */ }, 
    { "utmpcd", 431 /*     UTMPCD */ }, 
    { "iasd", 432 /*     IASD */ }, 
    { "nnsp", 433 /*     NNSP */ }, 
    { "mobileip-agent", 434 /*     MobileIP-Agent */ }, 
    { "mobilip-mn", 435 /*     MobilIP-MN */ }, 
    { "dna-cml", 436 /*     DNA-CML */ }, 
    { "comscm", 437 /*     comscm */ }, 
    { "dsfgw", 438 /*     dsfgw */ }, 
    { "dasp", 439 /*     dasp      tommy@inlab.m.eunet.de */ }, 
    { "sgcp", 440 /*     sgcp */ }, 
    { "decvms-sysmgt", 441 /*     decvms-sysmgt */ }, 
    { "cvc_hostd", 442 /*     cvc_hostd */ }, 
    { "https", 443 /*     https  MCom */ }, 
    { "snpp", 444 /*     Simple Network Paging Protocol */ }, 
    { "microsoft-ds", 445 /*     Microsoft-DS */ }, 
    { "ddm-rdb", 446 /*     DDM-RDB */ }, 
    { "ddm-dfm", 447 /*     DDM-RFM */ }, 
    { "ddm-byte", 448 /*     DDM-BYTE */ }, 
    { "as-servermap", 449 /*     AS Server Mapper */ }, 
    { "tserver", 450 /*     TServer */ }, 
    { "biff", 512 /*     used by mail system to notify users */ },
    { "who", 513 /*     maintains data bases showing who's */ }, 
    { "syslog", 514 /*  */ }, 
    { "printer", 515 /*     spooler */ }, 
    { "talk", 517 /*     like tenex link, but across */ }, 
    { "ntalk", 518 /*  */ }, 
    { "utime", 519 /*     unixtime */ }, 
    { "router", 520 /*     local routing process (on site); */ }, 
    { "timed", 525 /*     timeserver */ }, 
    { "tempo", 526 /*     newdate */ }, 
    { "courier", 530 /*     rpc */ }, 
    { "conference", 531 /*     chat */ }, 
    { "netnews", 532 /*     readnews */ }, 
    { "netwall", 533 /*     for emergency broadcasts */ },
    { "apertus-ldp", 539 /*     Apertus Technologies Load Determination */ },
    { "uucp", 540 /*     uucpd */ }, 
    { "uucp-rlogin", 541 /*     uucp-rlogin  sl@wimsey.com */ }, 
    { "klogin", 543 /*  */ }, 
    { "kshell", 544 /*     krcmd */ }, 
    { "new-rwho", 550 /*     new-who */ }, 
    { "dsf", 555 /*  */ }, 
    { "remotefs", 556 /*     rfs server */ }, 
    { "rmonitor", 560 /*     rmonitord */ }, 
    { "monitor", 561 /*  */ }, 
    { "chshell", 562 /*     chcmd */ }, 
    { "whoami", 565 /*     whoami */ }, 
    { "meter", 570 /*     demon */ }, 
    { "meter", 571 /*     udemon */ }, 
    { "ipcserver", 600 /*     Sun IPC server */ }, 
    { "nqs", 607 /*     nqs */ }, 
    { "urm", 606 /*     Cray Unified Resource Manager */ }, 
    { "sift-uft", 608 /*     Sender-Initiated/Unsolicited File Transfer */ }, 
    { "npmp-trap", 609 /*     npmp-trap */ }, 
    { "npmp-local", 610 /*     npmp-local */ }, 
    { "npmp-gui", 611 /*     npmp-gui */ }, 
    { "ginad", 634 /*     ginad */ }, 
    { "mdqs", 666 /*  */ }, 
    { "elcsd", 704 /*     errlog copy/server daemon */ },
    { "entrustmanager", 709 /*     EntrustManager */ }, 
    { "netviewdm1", 729 /*     IBM NetView DM/6000 Server/Client */ }, 
    { "netviewdm2", 730 /*     IBM NetView DM/6000 send/tcp */ }, 
    { "netviewdm3", 731 /*     IBM NetView DM/6000 receive/tcp */ }, 
    { "netgw", 741 /*     netGW */ }, 
    { "netrcs", 742 /*     Network based Rev. Cont. Sys. */ }, 
    { "flexlm", 744 /*     Flexible License Manager */ }, 
    { "fujitsu-dev", 747 /*     Fujitsu Device Control */ }, 
    { "ris-cm", 748 /*     Russell Info Sci Calendar Manager */ }, 
    { "kerberos-adm", 749 /*     kerberos administration */ }, 
    { "loadav", 750 /*  */ }, 
    { "pump", 751 /*  */ }, 
    { "qrh", 752 /*  */ },
    { "rrh", 753 /*  */ },
    { "tell", 754 /*      send */ }, 
    { "nlogin", 758 /*  */ }, 
    { "con", 759 /*  */ }, 
    { "ns", 760 /*  */ }, 
    { "rxe", 761 /*  */ }, 
    { "quotad", 762 /*  */ }, 
    { "cycleserv", 763 /*  */ }, 
    { "omserv", 764 /*  */ }, 
    { "webster", 765 /*  */ }, 
    { "phonebook", 767 /*     phone */ }, 
    { "vid", 769 /*  */ }, 
    { "cadlock", 770 /*  */ }, 
    { "rtip", 771 /*  */ }, 
    { "cycleserv2", 772 /*  */ }, 
    { "notify", 773 /*  */ }, 
    { "acmaint_dbd", 774 /*  */ }, 
    { "acmaint_transd", 775 /*  */ }, 
    { "wpages", 776 /*  */ }, 
    { "wpgs", 780 /*  */ }, 
    { "concert", 786 /*        Concert */ }, 
    { "mdbs_daemon", 800 /*  */ }, 
    { "device", 801 /*  */ }, 
    { "xtreelic", 996 /*         Central Point Software */ },
    { "maitrd", 997 /*  */ }, 
    { "puparp", 998 /*  */ }, 
    { "applix", 999 /*         Applix ac */ }, 
    { "puprouter", 999 /*  */ }, 
    { "ock", 1000 /* p */ }, 
    { "blackjack", 1025 /* p   network blackjack */ }, 
    { "iad1", 1030 /* p   BBN IAD */ }, 
    { "iad2", 1031 /* p   BBN IAD */ }, 
    { "iad3", 1032 /* p   BBN IAD */ }, 
    { "instl_boots", 1067 /* p   Installation Bootstrap Proto. Serv. */ }, 
    { "instl_bootc", 1068 /* p   Installation Bootstrap Proto. Cli. */ }, 
    { "socks", 1080 /* p   Socks */ }, 
    { "ansoft-lm-1", 1083 /* p   Anasoft License Manager */ },
    { "ansoft-lm-2", 1084 /* p   Anasoft License Manager */ },
    { "nfa", 1155 /* p   Network File Access */ }, 
    { "nerv", 1222 /* p   SNI R&D network */ }, 
    { "hermes", 1248 /* p */ }, 
    { "alta-ana-lm", 1346 /* p   Alta Analytics License Manager */ }, 
    { "bbn-mmc", 1347 /* p   multi media conferencing */ }, 
    { "bbn-mmx", 1348 /* p   multi media conferencing */ }, 
    { "sbook", 1349 /* p   Registration Network Protocol */ }, 
    { "editbench", 1350 /* p   Registration Network Protocol */ }, 
    { "equationbuilder", 1351 /* p   Digital Tool Works (MIT) */ }, 
    { "lotusnote", 1352 /* p   Lotus Note */ }, 
    { "relief", 1353 /* p   Relief Consulting */ }, 
    { "rightbrain", 1354 /* p   RightBrain Software */ }, 
    { "cuillamartin", 1356 /* p   CuillaMartin Company */ }, 
    { "pegboard", 1357 /* p   Electronic PegBoard */ }, 
    { "connlcli", 1358 /* p   CONNLCLI */ }, 
    { "ftsrv", 1359 /* p   FTSRV */ }, 
    { "mimer", 1360 /* p   MIMER */ }, 
    { "linx", 1361 /* p   LinX */ }, 
    { "timeflies", 1362 /* p   TimeFlies */ }, 
    { "ndm-requester", 1363 /* p   Network DataMover Requester */ }, 
    { "ndm-server", 1364 /* p   Network DataMover Server */ }, 
    { "adapt-sna", 1365 /* p   Network Software Associates */ }, 
    { "netware-csp", 1366 /* p   Novell NetWare Comm Service Platform */ },
    { "dcs", 1367 /* p   DCS */ }, 
    { "screencast", 1368 /* p   ScreenCast */ }, 
    { "gv-us", 1369 /* p   GlobalView to Unix Shell */ }, 
    { "us-gv", 1370 /* p   Unix Shell to GlobalView */ }, 
    { "fc-cli", 1371 /* p   Fujitsu Config Protocol */ }, 
    { "fc-ser", 1372 /* p   Fujitsu Config Protocol */ }, 
    { "chromagrafx", 1373 /* p   Chromagrafx */ }, 
    { "molly", 1374 /* p   EPI Software Systems */ }, 
    { "bytex", 1375 /* p   Bytex */ }, 
    { "ibm-pps", 1376 /* p   IBM Person to Person Software */ }, 
    { "cichlid", 1377 /* p   Cichlid License Manager */ }, 
    { "elan", 1378 /* p   Elan License Manager */ }, 
    { "dbreporter", 1379 /* p   Integrity Solutions */ },
    { "telesis-licman", 1380 /* p   Telesis Network License Manager */ },
    { "apple-licman", 1381 /* p   Apple Network License Manager */ }, 
    { "udt_os", 1382 /* p */ }, 
    { "gwha", 1383 /* p   GW Hannaway Network License Manager */ }, 
    { "os-licman", 1384 /* p   Objective Solutions License Manager */ }, 
    { "atex_elmd", 1385 /* p   Atex Publishing License Manager */ }, 
    { "checksum", 1386 /* p   CheckSum License Manager */ }, 
    { "cadsi-lm", 1387 /* p   Computer Aided Design Software Inc LM */ }, 
    { "objective-dbc", 1388 /* p   Objective Solutions DataBase Cache */ }, 
    { "iclpv-dm", 1389 /* p   Document Manager */ }, 
    { "iclpv-sc", 1390 /* p   Storage Controller */ }, 
    { "iclpv-sas", 1391 /* p   Storage Access Server */ }, 
    { "iclpv-pm", 1392 /* p   Print Manager */ }, 
    { "iclpv-nls", 1393 /* p   Network Log Server */ }, 
    { "iclpv-nlc", 1394 /* p   Network Log Client */ }, 
    { "iclpv-wsm", 1395 /* p   PC Workstation Manager software */ }, 
    { "dvl-activemail", 1396 /* p   DVL Active Mail */ }, 
    { "audio-activmail", 1397 /* p   Audio Active Mail */ }, 
    { "video-activmail", 1398 /* p   Video Active Mail */ }, 
    { "cadkey-licman", 1399 /* p   Cadkey License Manager */ }, 
    { "cadkey-tablet", 1400 /* p   Cadkey Tablet Daemon */ }, 
    { "goldleaf-licman", 1401 /* p   Goldleaf License Manager */ }, 
    { "prm-sm-np", 1402 /* p   Prospero Resource Manager */ }, 
    { "prm-nm-np", 1403 /* p   Prospero Resource Manager */ },
    { "igi-lm", 1404 /* p   Infinite Graphics License Manager */ }, 
    { "ibm-res", 1405 /* p   IBM Remote Execution Starter */ }, 
    { "netlabs-lm", 1406 /* p   NetLabs License Manager */ }, 
    { "dbsa-lm", 1407 /* p   DBSA License Manager */ }, 
    { "sophia-lm", 1408 /* p   Sophia License Manager */ }, 
    { "here-lm", 1409 /* p   Here License Manager */ }, 
    { "hiq", 1410 /* p   HiQ License Manager */ }, 
    { "af", 1411 /* p   AudioFile */ }, 
    { "innosys", 1412 /* p   InnoSys */ }, 
    { "innosys-acl", 1413 /* p   Innosys-ACL */ }, 
    { "ibm-mqseries", 1414 /* p   IBM MQSeries */ }, 
    { "dbstar", 1415 /* p   DBStar */ }, 
    { "novell-lu6.2", 1416 /* p   Novell LU6.2 */ },
    { "timbuktu-srv2", 1418 /* p   Timbuktu Service 2 Port */ },
    { "timbuktu-srv3", 1419 /* p   Timbuktu Service 3 Port */ }, 
    { "timbuktu-srv4", 1420 /* p   Timbuktu Service 4 Port */ }, 
    { "gandalf-lm", 1421 /* p   Gandalf License Manager */ }, 
    { "autodesk-lm", 1422 /* p   Autodesk License Manager */ }, 
    { "essbase", 1423 /* p   Essbase Arbor Software */ }, 
    { "hybrid", 1424 /* p   Hybrid Encryption Protocol */ }, 
    { "zion-lm", 1425 /* p   Zion Software License Manager */ }, 
    { "sas-1", 1426 /* p   Satellite-data Acquisition System 1 */ }, 
    { "mloadd", 1427 /* p   mloadd monitoring tool */ }, 
    { "informatik-lm", 1428 /* p   Informatik License Manager */ }, 
    { "nms", 1429 /* p   Hypercom NMS */ }, 
    { "tpdu", 1430 /* p   Hypercom TPDU */ }, 
    { "rgtp", 1431 /* p   Reverse Gosip Transport */ }, 
    { "blueberry-lm", 1432 /* p   Blueberry Software License Manager */ }, 
    { "ms-sql-s", 1433 /* p   Microsoft-SQL-Server */ }, 
    { "ms-sql-m", 1434 /* p   Microsoft-SQL-Monitor */ }, 
    { "ibm-cics", 1435 /* p   IBM CISC */ }, 
    { "sas-2", 1436 /* p   Satellite-data Acquisition System 2 */ }, 
    { "tabula", 1437 /* p   Tabula */ }, 
    { "eicon-server", 1438 /* p   Eicon Security Agent/Server */ }, 
    { "eicon-x25", 1439 /* p   Eicon X25/SNA Gateway */ }, 
    { "eicon-slp", 1440 /* p   Eicon Service Location Protocol */ }, 
    { "cadis-1", 1441 /* p   Cadis License Management */ },
    { "cadis-2", 1442 /* p   Cadis License Management */ }, 
    { "ies-lm", 1443 /* p   Integrated Engineering Software */ }, 
    { "marcam-lm", 1444 /* p   Marcam  License Management */ }, 
    { "proxima-lm", 1445 /* p   Proxima License Manager */ }, 
    { "ora-lm", 1446 /* p   Optical Research Associates License Manager */ }, 
    { "apri-lm", 1447 /* p   Applied Parallel Research LM */ }, 
    { "oc-lm", 1448 /* p   OpenConnect License Manager */ }, 
    { "peport", 1449 /* p   PEport */ }, 
    { "dwf", 1450 /* p   Tandem Distributed Workbench Facility */ }, 
    { "infoman", 1451 /* p   IBM Information Management */ }, 
    { "gtegsc-lm", 1452 /* p   GTE Government Systems License Man */ }, 
    { "genie-lm", 1453 /* p   Genie License Manager */ }, 
    { "esl-lm", 1455 /* p   ESL License Manager */ },
    { "dca", 1456 /* p   DCA */ },
    { "valisys-lm", 1457 /* p    Valisys License Manager */ }, 
    { "nrcabq-lm", 1458 /* p    Nichols Research Corp. */ }, 
    { "proshare1", 1459 /* p    Proshare Notebook Application */ }, 
    { "proshare2", 1460 /* p    Proshare Notebook Application */ }, 
    { "ibm_wrless_lan", 1461 /* p    IBM Wireless LAN */ }, 
    { "world-lm", 1462 /* p    World License Manager */ }, 
    { "nucleus", 1463 /* p    Nucleus */ }, 
    { "msl_lmd", 1464 /* p    MSL License Manager */ }, 
    { "pipes", 1465 /* p    Pipes Platform  mfarlin@peerlogic.com */ }, 
    { "oceansoft-lm", 1466 /* p    Ocean Software License Manager */ }, 
    { "csdmbase", 1467 /* p    CSDMBASE */ }, 
    { "csdm", 1468 /* p    CSDM */ }, 
    { "aal-lm", 1469 /* p    Active Analysis Limited License Manager */ }, 
    { "uaiact", 1470 /* p    Universal Analytics */ }, 
    { "csdmbase", 1471 /* p    csdmbase */ }, 
    { "csdm", 1472 /* p    csdm */ }, 
    { "openmath", 1473 /* p    OpenMath */ }, 
    { "telefinder", 1474 /* p    Telefinder */ }, 
    { "taligent-lm", 1475 /* p    Taligent License Manager */ }, 
    { "clvm-cfg", 1476 /* p    clvm-cfg */ }, 
    { "ms-sna-server", 1477 /* p    ms-sna-server */ }, 
    { "ms-sna-base", 1478 /* p    ms-sna-base */ }, 
    { "dberegister", 1479 /* p    dberegister */ },
    { "pacerforum", 1480 /* p    PacerForum */ }, 
    { "airs", 1481 /* p    AIRS */ }, 
    { "miteksys-lm", 1482 /* p    Miteksys License Manager */ }, 
    { "afs", 1483 /* p    AFS License Manager */ }, 
    { "confluent", 1484 /* p    Confluent License Manager */ }, 
    { "lansource", 1485 /* p    LANSource */ }, 
    { "nms_topo_serv", 1486 /* p    nms_topo_serv */ }, 
    { "localinfosrvr", 1487 /* p    LocalInfoSrvr */ }, 
    { "docstor", 1488 /* p    DocStor */ }, 
    { "dmdocbroker", 1489 /* p    dmdocbroker */ }, 
    { "insitu-conf", 1490 /* p    insitu-conf */ }, 
    { "anynetgateway", 1491 /* p    anynetgateway */ }, 
    { "stone-design-1", 1492 /* p    stone-design-1 */ },
    { "netmap_lm", 1493 /* p    netmap_lm */ },
    { "ica", 1494 /* p    ica */ }, 
    { "cvc", 1495 /* p    cvc */ }, 
    { "liberty-lm", 1496 /* p    liberty-lm */ }, 
    { "rfx-lm", 1497 /* p    rfx-lm */ }, 
    { "watcom-sql", 1498 /* p    Watcom-SQL */ }, 
    { "fhc", 1499 /* p    Federico Heinz Consultora */ }, 
    { "vlsi-lm", 1500 /* p    VLSI License Manager */ }, 
    { "sas-3", 1501 /* p    Satellite-data Acquisition System 3 */ }, 
    { "shivadiscovery", 1502 /* p    Shiva */ }, 
    { "imtc-mcs", 1503 /* p    Databeam */ }, 
    { "evb-elm", 1504 /* p    EVB Software Engineering License Manager */ }, 
    { "funkproxy", 1505 /* p    Funk Software, Inc. */ }, 
    { "ingreslock", 1524 /* p    ingres */ }, 
    { "orasrv", 1525 /* p    oracle */ }, 
    { "prospero-np", 1525 /* p    Prospero Directory Service non-priv */ }, 
    { "pdap-np", 1526 /* p    Prospero Data Access Prot non-priv */ }, 
    { "tlisrv", 1527 /* p    oracle */ }, 
    { "coauthor", 1529 /* p    oracle */ }, 
    { "issd", 1600 /* p */ }, 
    { "nkd", 1650 /* p */ }, 
    { "proshareaudio", 1651 /* p   proshare conf audio */ }, 
    { "prosharevideo", 1652 /* p   proshare conf video */ }, 
    { "prosharedata", 1653 /* p   proshare conf data */ },
    { "prosharerequest", 1654 /* p   proshare conf request */ }, 
    { "prosharenotify", 1655 /* p   proshare conf notify */ }, 
    { "netview-aix-1", 1661 /* p   netview-aix-1 */ }, 
    { "netview-aix-2", 1662 /* p   netview-aix-2 */ }, 
    { "netview-aix-3", 1663 /* p   netview-aix-3 */ }, 
    { "netview-aix-4", 1664 /* p   netview-aix-4 */ }, 
    { "netview-aix-5", 1665 /* p   netview-aix-5 */ }, 
    { "netview-aix-6", 1666 /* p   netview-aix-6 */ }, 
    { "licensedaemon", 1986 /* p   cisco license management */ }, 
    { "tr-rsrb-p1", 1987 /* p   cisco RSRB Priority 1 port */ }, 
    { "tr-rsrb-p2", 1988 /* p   cisco RSRB Priority 2 port */ }, 
    { "tr-rsrb-p3", 1989 /* p   cisco RSRB Priority 3 port */ }, 
    { "mshnet", 1989 /* p   MHSnet system */ },
    { "stun-p1", 1990 /* p   cisco STUN Priority 1 port */ },
    { "stun-p2", 1991 /* p   cisco STUN Priority 2 port */ }, 
    { "stun-p3", 1992 /* p   cisco STUN Priority 3 port */ }, 
    { "ipsendmsg", 1992 /* p   IPsendmsg */ }, 
    { "snmp-tcp-port", 1993 /* p   cisco SNMP TCP port */ }, 
    { "stun-port", 1994 /* p   cisco serial tunnel port */ }, 
    { "perf-port", 1995 /* p   cisco perf port */ }, 
    { "tr-rsrb-port", 1996 /* p   cisco Remote SRB port */ }, 
    { "gdp-port", 1997 /* p   cisco Gateway Discovery Protocol */ }, 
    { "x25-svc-port", 1998 /* p   cisco X.25 service (XOT) */ }, 
    { "tcp-id-port", 1999 /* p   cisco identification port */ }, 
    { "callbook", 2000 /* p */ }, 
    { "wizard", 2001 /* p    curry */ }, 
    { "globe", 2002 /* p */ }, 
    { "emce", 2004 /* p    CCWS mm conf */ }, 
    { "oracle", 2005 /* p */ }, 
    { "raid-cc", 2006 /* p    raid */ }, 
    { "raid-am", 2007 /* p */ }, 
    { "terminaldb", 2008 /* p */ }, 
    { "whosockami", 2009 /* p */ }, 
    { "pipe_server", 2010 /* p */ }, 
    { "servserv", 2011 /* p */ }, 
    { "raid-ac", 2012 /* p */ }, 
    { "raid-cd", 2013 /* p */ },
    { "raid-sf", 2014 /* p */ }, 
    { "raid-cs", 2015 /* p */ }, 
    { "bootserver", 2016 /* p */ }, 
    { "bootclient", 2017 /* p */ }, 
    { "rellpack", 2018 /* p */ }, 
    { "about", 2019 /* p */ }, 
    { "xinupageserver", 2020 /* p */ }, 
    { "xinuexpansion1", 2021 /* p */ }, 
    { "xinuexpansion2", 2022 /* p */ }, 
    { "xinuexpansion3", 2023 /* p */ }, 
    { "xinuexpansion4", 2024 /* p */ }, 
    { "xribs", 2025 /* p */ }, 
    { "scrabble", 2026 /* p */ },
    { "shadowserver", 2027 /* p */ },
    { "submitserver", 2028 /* p */ }, 
    { "device2", 2030 /* p */ }, 
    { "blackboard", 2032 /* p */ }, 
    { "glogger", 2033 /* p */ }, 
    { "scoremgr", 2034 /* p */ },
    { "imsldoc", 2035 /* p */ }, 
    { "objectmanager", 2038 /* p */ }, 
    { "lam", 2040 /* p */ }, 
    { "interbase", 2041 /* p */ }, 
    { "isis", 2042 /* p */ }, 
    { "isis-bcast", 2043 /* p */ }, 
    { "rimsl", 2044 /* p */ }, 
    { "cdfunc", 2045 /* p */ }, 
    { "sdfunc", 2046 /* p */ }, 
    { "dls", 2047 /* p */ }, 
    { "dls-monitor", 2048 /* p */ }, 
    { "shilp", 2049 /* p */ }, 
    { "dlsrpn", 2065 /* p   Data Link Switch Read Port Number */ }, 
    { "dlswpn", 2067 /* p   Data Link Switch Write Port Number */ }, 
    { "ats", 2201 /* p   Advanced Training System Program */ }, 
    { "rtsserv", 2500 /* p   Resource Tracking system server */ }, 
    { "rtsclient", 2501 /* p   Resource Tracking system client */ }, 
    { "www-dev", 2784 /* p   world wide web - development */ },
    { "NSWS", 3049 /* p */ }, 
    { "ccmail", 3264 /* p   cc:mail/lotus */ }, 
    { "dec-notes", 3333 /* p   DEC Notes */ }, 
    { "mapper-nodemgr", 3984 /* udp     MAPPER network node manager */ }, 
    { "mapper-mapethd", 3985 /* udp     MAPPER TCP/IP server */ }, 
    { "mapper-ws_ethd", 3986 /* udp     MAPPER workstation server */ }, 
    { "bmap", 3421 /* p   Bull Apprise portmapper */ }, 
    { "udt_os", 3900 /* p   Unidata UDT OS */ }, 
    { "nuts_dem", 4132 /* p   NUTS Daemon */ }, 
    { "nuts_bootp", 4133 /* p   NUTS Bootp Server */ }, 
    { "unicall", 4343 /* p   UNICALL */ }, 
    { "krb524", 4444 /* p   KRB524 */ }, 
    { "rfa", 4672 /* p   remote file access server */ },
    { "commplex-main", 5000 /* p */ },
    { "commplex-link", 5001 /* p */ }, 
    { "rfe", 5002 /* p   radio free ethernet */ }, 
    { "telelpathstart", 5010 /* p   TelepathStart */ }, 
    { "telelpathattack", 5011 /* p   TelepathAttack */ }, 
    { "mmcc", 5050 /* p   multimedia conference control tool */ },
    { "rmonitor_secure", 5145 /* p */ }, 
    { "aol", 5190 /* p   America-Online */ }, 
    { "padl2sim", 5236 /* p */ }, 
    { "hacl-hb", 5300 /* p        # HA cluster heartbeat */ }, 
    { "hacl-gs", 5301 /* p        # HA cluster general services */ }, 
    { "hacl-cfg", 5302 /* p        # HA cluster configuration */ }, 
    { "hacl-probe", 5303 /* p        # HA cluster probing */ }, 
    { "hacl-local", 5304 /* p */ }, 
    { "hacl-test", 5305 /* p */ },
    { "x11", 6000 /* 63/udp   X Window System */ },
    { "x11", 6001 /* 63/udp   X Window System */ },
    { "x11", 6002 /* 63/udp   X Window System */ },
    { "x11", 6003 /* 63/udp   X Window System */ },
    { "sub-process", 6111 /* p   HP SoftBench Sub-Process Control */ }, 
    { "meta-corp", 6141 /* p   Meta Corporation License Manager */ }, 
    { "aspentec-lm", 6142 /* p   Aspen Technology License Manager */ }, 
    { "watershed-lm", 6143 /* p   Watershed License Manager */ }, 
    { "statsci1-lm", 6144 /* p   StatSci License Manager - 1 */ }, 
    { "statsci2-lm", 6145 /* p   StatSci License Manager - 2 */ }, 
    { "lonewolf-lm", 6146 /* p   Lone Wolf Systems License Manager */ }, 
    { "montage-lm", 6147 /* p   Montage License Manager */ },
    { "xdsxdm", 6558 /* p */ }, 
    { "afs3-fileserver", 7000 /* p   file server itself */ }, 
    { "afs3-callback", 7001 /* p   callbacks to cache managers */ }, 
    { "afs3-prserver", 7002 /* p   users & groups database */ }, 
    { "afs3-vlserver", 7003 /* p   volume location database */ }, 
    { "afs3-kaserver", 7004 /* p   AFS/Kerberos authentication service */ }, 
    { "afs3-volser", 7005 /* p   volume managment server */ }, 
    { "afs3-errors", 7006 /* p   error interpretation service */ }, 
    { "afs3-bos", 7007 /* p   basic overseer process */ }, 
    { "afs3-update", 7008 /* p   server-to-server updater */ }, 
    { "afs3-rmtsys", 7009 /* p   remote cache manager service */ }, 
    { "ups-onlinet", 7010 /* p   onlinet uninterruptable power supplies */ }, 
    { "font-service", 7100 /* p   X Font Service */ },
    { "fodms", 7200 /* p   FODMS FLIP */ },
    { "man", 9535 /* p */ },
    { "isode-dua", 17007 /* dp */ },
};

AssPort::SAssPort AssPort::tcpPort[] = {
    { "tcpmux", 1 /*     TCP Port Service Multiplexer */ },
    { "compressnet", 2 /*     Management Utility */ }, 
    { "compressnet", 3 /*     Compression Process */ }, 
    { "rje", 5 /*     Remote Job Entry */ }, 
    { "echo", 7 /*     Echo */ }, 
    { "discard", 9 /*     Discard */ }, 
    { "systat", 11 /*     Active Users */ }, 
    { "daytime", 13 /*     Daytime */ }, 
    { "qotd", 17 /*     Quote of the Day */ }, 
    { "msp", 18 /*     Message Send Protocol */ }, 
    { "chargen", 19 /*     Character Generator */ }, 
    { "ftp-data", 20 /*     File Transfer [Default Data] */ }, 
    { "ftp", 21 /*     File Transfer [Control] */ }, 
    { "telnet", 23 /*     Telnet */ }, 
    { "smtp", 25 /*     Simple Mail Transfer */ }, 
    { "nsw-fe", 27 /*     NSW User System FE */ }, 
    { "msg-icp", 29 /*     MSG ICP */ }, 
    { "msg-auth", 31 /*     MSG Authentication */ },
    { "dsp", 33 /*     Display Support Protocol */ }, 
    { "time", 37 /*     Time */ }, 
    { "rap", 38 /*     Route Access Protocol */ }, 
    { "rlp", 39 /*     Resource Location Protocol */ }, 
    { "graphics", 41 /*     Graphics */ }, 
    { "nameserver", 42 /*     Host Name Server */ }, 
    { "nicname", 43 /*     Who Is */ }, 
    { "mpm-flags", 44 /*     MPM FLAGS Protocol */ }, 
    { "mpm", 45 /*     Message Processing Module [recv] */ }, 
    { "mpm-snd", 46 /*     MPM [default send] */ }, 
    { "ni-ftp", 47 /*     NI FTP */ }, 
    { "auditd", 48 /*     Digital Audit Daemon */ }, 
    { "login", 49 /*     Login Host Protocol */ },
    { "re-mail-ck", 50 /*     Remote Mail Checking Protocol */ },
    { "la-maint", 51 /*     IMP Logical Address Maintenance */ }, 
    { "xns-time", 52 /*     XNS Time Protocol */ }, 
    { "domain", 53 /*     Domain Name Server */ }, 
    { "xns-ch", 54 /*     XNS Clearinghouse */ }, 
    { "isi-gl", 55 /*     ISI Graphics Language */ },
    { "xns-auth", 56 /*     XNS Authentication */ }, 
    { "xns-mail", 58 /*     XNS Mail */ }, 
    { "ni-mail", 61 /*     NI MAIL */ }, 
    { "acas", 62 /*     ACA Services */ }, 
    { "covia", 64 /*     Communications Integrator (CI) */ }, 
    { "tacacs-ds", 65 /*     TACACS-Database Service */ }, 
    { "sql*net", 66 /*     Oracle SQL*NET */ }, 
    { "bootps", 67 /*     Bootstrap Protocol Server */ }, 
    { "bootpc", 68 /*     Bootstrap Protocol Client */ }, 
    { "tftp", 69 /*     Trivial File Transfer */ }, 
    { "gopher", 70 /*     Gopher */ }, 
    { "netrjs-1", 71 /*     Remote Job Service */ }, 
    { "netrjs-2", 72 /*     Remote Job Service */ }, 
    { "netrjs-3", 73 /*     Remote Job Service */ }, 
    { "netrjs-4", 74 /*     Remote Job Service */ }, 
    { "deos", 76 /*     Distributed External Object Store */ }, 
    { "vettcp", 78 /*     vettcp */ }, 
    { "finger", 79 /*     Finger */ },
    { "www-http", 80 /*     World Wide Web HTTP */ }, 
    { "hosts2-ns", 81 /*     HOSTS2 Name Server */ }, 
    { "xfer", 82 /*     XFER Utility */ }, 
    { "mit-ml-dev", 83 /*     MIT ML Device */ }, 
    { "ctf", 84 /*     Common Trace Facility */ }, 
    { "mit-ml-dev", 85 /*     MIT ML Device */ }, 
    { "mfcobol", 86 /*     Micro Focus Cobol */ }, 
    { "kerberos", 88 /*     Kerberos */ }, 
    { "su-mit-tg", 89 /*     SU/MIT Telnet Gateway */ }, 
    { "dnsix", 90 /*     DNSIX Securit Attribute Token Map */ }, 
    { "mit-dov", 91 /*     MIT Dover Spooler */ }, 
    { "npp", 92 /*     Network Printing Protocol */ }, 
    { "dcp", 93 /*     Device Control Protocol */ },
    { "objcall", 94 /*     Tivoli Object Dispatcher */ }, 
    { "supdup", 95 /*     SUPDUP */ }, 
    { "dixie", 96 /*     DIXIE Protocol Specification */ }, 
    { "swift-rvf", 97 /*     Swift Remote Vitural File Protocol */ }, 
    { "tacnews", 98 /*     TAC News */ }, 
    { "metagram", 99 /*     Metagram Relay */ },
    { "newacct", 100 /*     [unauthorized use] */ }, 
    { "hostname", 101 /*     NIC Host Name Server */ }, 
    { "iso-tsap", 102 /*     ISO-TSAP */ }, 
    { "gppitnp", 103 /*     Genesis Point-to-Point Trans Net */ }, 
    { "acr-nema", 104 /*     ACR-NEMA Digital Imag. & Comm. 300 */ }, 
    { "csnet-ns", 105 /*     Mailbox Name Nameserver */ }, 
    { "rtelnet", 107 /*     Remote Telnet Service */ }, 
    { "snagas", 108 /*     SNA Gateway Access Server */ }, 
    { "pop2", 109 /*     Post Office Protocol - Version 2 */ }, 
    { "pop3", 110 /*     Post Office Protocol - Version 3 */ }, 
    { "sunrpc", 111 /*     SUN Remote Procedure Call */ }, 
    { "mcidas", 112 /*     McIDAS Data Transmission Protocol */ }, 
    { "auth", 113 /*     Authentication Service */ }, 
    { "audionews", 114 /*     Audio News Multicast */ }, 
    { "sftp", 115 /*     Simple File Transfer Protocol */ }, 
    { "ansanotify", 116 /*     ANSA REX Notify */ }, 
    { "uucp-path", 117 /*     UUCP Path Service */ }, 
    { "sqlserv", 118 /*     SQL Services */ },
    { "nntp", 119 /*     Network News Transfer Protocol */ }, 
    { "cfdptkt", 120 /*     CFDPTKT */ }, 
    { "erpc", 121 /*     Encore Expedited Remote Pro.Call */ }, 
    { "smakynet", 122 /*     SMAKYNET */ }, 
    { "ntp", 123 /*     Network Time Protocol */ }, 
    { "ansatrader", 124 /*     ANSA REX Trader */ }, 
    { "locus-map", 125 /*     Locus PC-Interface Net Map Ser */ }, 
    { "unitary", 126 /*     Unisys Unitary Login */ }, 
    { "locus-con", 127 /*     Locus PC-Interface Conn Server */ }, 
    { "gss-xlicen", 128 /*     GSS X License Verification */ }, 
    { "pwdgen", 129 /*     Password Generator Protocol */ }, 
    { "cisco-fna", 130 /*     cisco FNATIVE */ }, 
    { "cisco-tna", 131 /*     cisco TNATIVE */ },
    { "cisco-sys", 132 /*     cisco SYSMAINT */ }, 
    { "statsrv", 133 /*     Statistics Service */ }, 
    { "ingres-net", 134 /*     INGRES-NET Service */ }, 
    { "loc-srv", 135 /*     Location Service */ }, 
    { "profile", 136 /*     PROFILE Naming System */ }, 
    { "netbios-ns", 137 /*     NETBIOS Name Service */ },
    { "netbios-dgm", 138 /*     NETBIOS Datagram Service */ }, 
    { "netbios-ssn", 139 /*     NETBIOS Session Service */ }, 
    { "emfis-data", 140 /*     EMFIS Data Service */ }, 
    { "emfis-cntl", 141 /*     EMFIS Control Service */ }, 
    { "bl-idm", 142 /*     Britton-Lee IDM */ }, 
    { "imap2", 143 /*     Interim Mail Access Protocol v2 */ }, 
    { "news", 144 /*     NewS */ }, 
    { "uaac", 145 /*     UAAC Protocol */ }, 
    { "iso-tp0", 146 /*     ISO-IP0 */ }, 
    { "iso-ip", 147 /*     ISO-IP */ }, 
    { "cronus", 148 /*     CRONUS-SUPPORT */ }, 
    { "aed-512", 149 /*     AED 512 Emulation Service */ }, 
    { "sql-net", 150 /*     SQL-NET */ }, 
    { "hems", 151 /*     HEMS */ }, 
    { "bftp", 152 /*     Background File Transfer Program */ }, 
    { "sgmp", 153 /*     SGMP */ }, 
    { "netsc-prod", 154 /*     NETSC */ }, 
    { "netsc-dev", 155 /*     NETSC */ },
    { "sqlsrv", 156 /*     SQL Service */ }, 
    { "knet-cmp", 157 /*     KNET/VM Command/Message Protocol */ }, 
    { "pcmail-srv", 158 /*     PCMail Server */ }, 
    { "nss-routing", 159 /*     NSS-Routing */ }, 
    { "sgmp-traps", 160 /*     SGMP-TRAPS */ }, 
    { "snmp", 161 /*     SNMP */ }, 
    { "snmptrap", 162 /*     SNMPTRAP */ }, 
    { "cmip-man", 163 /*     CMIP/TCP Manager */ }, 
    { "cmip-agent", 164 /*     CMIP/TCP Agent */ }, 
    { "xns-courier", 165 /*     Xerox */ }, 
    { "s-net", 166 /*     Sirius Systems */ }, 
    { "namp", 167 /*     NAMP */ }, 
    { "rsvd", 168 /*     RSVD */ },
    { "send", 169 /*     SEND */ }, 
    { "print-srv", 170 /*     Network PostScript */ }, 
    { "multiplex", 171 /*     Network Innovations Multiplex */ }, 
    { "cl/1", 172 /*     Network Innovations CL/1 */ }, 
    { "xyplex-mux", 173 /*     Xyplex */ }, 
    { "mailq", 174 /*     MAILQ */ },
    { "vmnet", 175 /*     VMNET */ }, 
    { "genrad-mux", 176 /*     GENRAD-MUX */ }, 
    { "xdmcp", 177 /*     X Display Manager Control Protocol */ }, 
    { "nextstep", 178 /*     NextStep Window Server */ }, 
    { "bgp", 179 /*     Border Gateway Protocol */ }, 
    { "ris", 180 /*     Intergraph */ }, 
    { "unify", 181 /*     Unify */ }, 
    { "audit", 182 /*     Unisys Audit SITP */ }, 
    { "ocbinder", 183 /*     OCBinder */ }, 
    { "ocserver", 184 /*     OCServer */ }, 
    { "remote-kis", 185 /*     Remote-KIS */ }, 
    { "kis", 186 /*     KIS Protocol */ }, 
    { "aci", 187 /*     Application Communication Interface */ }, 
    { "mumps", 188 /*     Plus Five's MUMPS */ }, 
    { "qft", 189 /*     Queued File Transport */ }, 
    { "gacp", 190 /*     Gateway Access Control Protocol */ }, 
    { "prospero", 191 /*     Prospero Directory Service */ }, 
    { "osu-nms", 192 /*     OSU Network Monitoring System */ },
    { "srmp", 193 /*     Spider Remote Monitoring Protocol */ }, 
    { "irc", 194 /*     Internet Relay Chat Protocol */ }, 
    { "dn6-nlm-aud", 195 /*     DNSIX Network Level Module Audit */ }, 
    { "dn6-smm-red", 196 /*     DNSIX Session Mgt Module Audit Redir */ }, 
    { "dls", 197 /*     Directory Location Service */ }, 
    { "dls-mon", 198 /*     Directory Location Service Monitor */ }, 
    { "smux", 199 /*     SMUX */ }, 
    { "src", 200 /*     IBM System Resource Controller */ }, 
    { "at-rtmp", 201 /*     AppleTalk Routing Maintenance */ }, 
    { "at-nbp", 202 /*     AppleTalk Name Binding */ }, 
    { "at-3", 203 /*     AppleTalk Unused */ }, 
    { "at-echo", 204 /*     AppleTalk Echo */ }, 
    { "at-5", 205 /*     AppleTalk Unused */ },
    { "at-zis", 206 /*     AppleTalk Zone Information */ }, 
    { "at-7", 207 /*     AppleTalk Unused */ }, 
    { "at-8", 208 /*     AppleTalk Unused */ }, 
    { "tam", 209 /*     Trivial Authenticated Mail Protocol */ }, 
    { "z39.50", 210 /*     ANSI Z39.50 */ }, 
    { "anet", 212 /*     ATEXSSTR */ },
    { "ipx", 213 /*     IPX */ }, 
    { "vmpwscs", 214 /*     VM PWSCS */ }, 
    { "softpc", 215 /*     Insignia Solutions */ }, 
    { "atls", 216 /*     Access Technology License Server */ }, 
    { "dbase", 217 /*     dBASE Unix */ }, 
    { "mpp", 218 /*     Netix Message Posting Protocol */ }, 
    { "uarps", 219 /*     Unisys ARPs */ }, 
    { "imap3", 220 /*     Interactive Mail Access Protocol v3 */ }, 
    { "fln-spx", 221 /*     Berkeley rlogind with SPX auth */ }, 
    { "rsh-spx", 222 /*     Berkeley rshd with SPX auth */ }, 
    { "cdc", 223 /*     Certificate Distribution Center */ }, 
    { "sur-meas", 243 /*     Survey Measurement */ }, 
    { "link", 245 /*     LINK */ }, 
    { "dsp3270", 246 /*     Display Systems Protocol */ }, 
    { "pdap", 344 /*     Prospero Data Access Protocol */ }, 
    { "pawserv", 345 /*     Perf Analysis Workbench */ }, 
    { "zserv", 346 /*     Zebra server */ }, 
    { "fatserv", 347 /*     Fatmen Server */ },
    { "csi-sgwp", 348 /*     Cabletron Management Protocol */ }, 
    { "clearcase", 371 /*     Clearcase */ }, 
    { "ulistserv", 372 /*     Unix Listserv */ }, 
    { "legent-1", 373 /*     Legent Corporation */ }, 
    { "legent-2", 374 /*     Legent Corporation */ }, 
    { "hassle", 375 /*     Hassle */ }, 
    { "nip", 376 /*     Amiga Envoy Network Inquiry Proto */ }, 
    { "tnETOS", 377 /*     NEC Corporation */ }, 
    { "dsETOS", 378 /*     NEC Corporation */ }, 
    { "is99c", 379 /*     TIA/EIA/IS-99 modem client */ }, 
    { "is99s", 380 /*     TIA/EIA/IS-99 modem server */ }, 
    { "hp-collector", 381 /*     hp performance data collector */ }, 
    { "hp-managed-node", 382 /*     hp performance data managed node */ },
    { "hp-alarm-mgr", 383 /*     hp performance data alarm manager */ }, 
    { "arns", 384 /*     A Remote Network Server System */ }, 
    { "ibm-app", 385 /*     IBM Application */ }, 
    { "ibm-app", 385 /*     IBM Application */ }, 
    { "asa", 386 /*     ASA Message Router Object Def. */ }, 
    { "aurp", 387 /*     Appletalk Update-Based Routing Pro. */ },
    { "unidata-ldm", 388 /*     Unidata LDM Version 4 */ }, 
    { "ldap", 389 /*     Lightweight Directory Access Protocol */ }, 
    { "uis", 390 /*     UIS */ }, 
    { "synotics-relay", 391 /*     SynOptics SNMP Relay Port */ }, 
    { "synotics-broker", 392 /*     SynOptics Port Broker Port */ }, 
    { "dis", 393 /*     Data Interpretation System */ }, 
    { "embl-ndt", 394 /*     EMBL Nucleic Data Transfer */ }, 
    { "netcp", 395 /*     NETscout Control Protocol */ }, 
    { "netware-ip", 396 /*     Novell Netware over IP */ }, 
    { "mptn", 397 /*     Multi Protocol Trans. Net. */ }, 
    { "kryptolan", 398 /*     Kryptolan */ }, 
    { "work-sol", 400 /*     Workstation Solutions */ }, 
    { "ups", 401 /*     Uninterruptible Power Supply */ }, 
    { "genie", 402 /*     Genie Protocol */ }, 
    { "decap", 403 /*     decap */ }, 
    { "nced", 404 /*     nced */ }, 
    { "ncld", 405 /*     ncld */ }, 
    { "imsp", 406 /*     Interactive Mail Support Protocol */ },
    { "timbuktu", 407 /*     Timbuktu */ }, 
    { "prm-sm", 408 /*     Prospero Resource Manager Sys. Man. */ }, 
    { "prm-nm", 409 /*     Prospero Resource Manager Node Man. */ }, 
    { "decladebug", 410 /*     DECLadebug Remote Debug Protocol */ }, 
    { "rmt", 411 /*     Remote MT Protocol */ }, 
    { "synoptics-trap", 412 /*     Trap Convention Port */ }, 
    { "smsp", 413 /*     SMSP */ }, 
    { "infoseek", 414 /*     InfoSeek */ }, 
    { "bnet", 415 /*     BNet */ }, 
    { "silverplatter", 416 /*     Silverplatter */ }, 
    { "onmux", 417 /*     Onmux */ }, 
    { "hyper-g", 418 /*     Hyper-G */ }, 
    { "ariel1", 419 /*     Ariel */ },
    { "smpte", 420 /*     SMPTE */ }, 
    { "ariel2", 421 /*     Ariel */ }, 
    { "ariel3", 422 /*     Ariel */ }, 
    { "opc-job-start", 423 /*     IBM Operations Planning and Control Start */ }, 
    { "opc-job-track", 424 /*     IBM Operations Planning and Control Track */ }, 
    { "icad-el", 425 /*     ICAD */ },
    { "smartsdp", 426 /*     smartsdp */ }, 
    { "svrloc", 427 /*     Server Location */ }, 
    { "ocs_cmu", 428 /*     OCS_CMU */ }, 
    { "ocs_amu", 429 /*     OCS_AMU */ }, 
    { "utmpsd", 430 /*     UTMPSD */ }, 
    { "utmpcd", 431 /*     UTMPCD */ }, 
    { "iasd", 432 /*     IASD */ }, 
    { "nnsp", 433 /*     NNSP */ }, 
    { "mobileip-agent", 434 /*     MobileIP-Agent */ }, 
    { "mobilip-mn", 435 /*     MobilIP-MN */ }, 
    { "dna-cml", 436 /*     DNA-CML */ }, 
    { "comscm", 437 /*     comscm */ }, 
    { "dsfgw", 438 /*     dsfgw */ }, 
    { "dasp", 439 /*     dasp      Thomas Obermair */ }, 
    { "sgcp", 440 /*     sgcp */ }, 
    { "decvms-sysmgt", 441 /*     decvms-sysmgt */ }, 
    { "cvc_hostd", 442 /*     cvc_hostd */ }, 
    { "https", 443 /*     https  MCom */ },
    { "snpp", 444 /*     Simple Network Paging Protocol */ }, 
    { "microsoft-ds", 445 /*     Microsoft-DS */ }, 
    { "ddm-rdb", 446 /*     DDM-RDB */ }, 
    { "ddm-dfm", 447 /*     DDM-RFM */ }, 
    { "ddm-byte", 448 /*     DDM-BYTE */ }, 
    { "as-servermap", 449 /*     AS Server Mapper */ }, 
    { "tserver", 450 /*     TServer */ }, 
    { "exec", 512 /*     remote process execution; */ }, 
    { "login", 513 /*     remote login a la telnet; */ }, 
    { "cmd", 514 /*     like exec, but automatic */ }, 
    { "printer", 515 /*     spooler */ }, 
    { "talk", 517 /*     like tenex link, but across */ }, 
    { "ntalk", 518 /*  */ },
    { "utime", 519 /*     unixtime */ }, 
    { "efs", 520 /*     extended file name server */ }, 
    { "timed", 525 /*     timeserver */ }, 
    { "tempo", 526 /*     newdate */ }, 
    { "courier", 530 /*     rpc */ }, 
    { "conference", 531 /*     chat */ },
    { "netnews", 532 /*     readnews */ }, 
    { "netwall", 533 /*     for emergency broadcasts */ }, 
    { "apertus-ldp", 539 /*     Apertus Technologies Load Determination */ }, 
    { "uucp", 540 /*     uucpd */ }, 
    { "uucp-rlogin", 541 /*     uucp-rlogin  Stuart Lynne */ }, 
    { "klogin", 543 /*  */ }, 
    { "kshell", 544 /*     krcmd */ }, 
    { "new-rwho", 550 /*     new-who */ }, 
    { "dsf", 555 /*  */ }, 
    { "remotefs", 556 /*     rfs server */ }, 
    { "rmonitor", 560 /*     rmonitord */ }, 
    { "monitor", 561 /*  */ }, 
    { "chshell", 562 /*     chcmd */ }, 
    { "whoami", 565 /*     whoami */ }, 
    { "meter", 570 /*     demon */ }, 
    { "meter", 571 /*     udemon */ }, 
    { "ipcserver", 600 /*     Sun IPC server */ }, 
    { "nqs", 607 /*     nqs */ },
    { "urm", 606 /*     Cray Unified Resource Manager */ }, 
    { "sift-uft", 608 /*     Sender-Initiated/Unsolicited File Transfer */ }, 
    { "npmp-trap", 609 /*     npmp-trap */ }, 
    { "npmp-local", 610 /*     npmp-local */ }, 
    { "npmp-gui", 611 /*     npmp-gui */ }, 
    { "ginad", 634 /*     ginad */ }, 
    { "mdqs", 666 /*  */ }, 
    { "doom", 666 /*     doom Id Software */ }, 
    { "doom", 666 /*     doom Id Software */ }, 
    { "elcsd", 704 /*     errlog copy/server daemon */ }, 
    { "entrustmanager", 709 /*     EntrustManager */ }, 
    { "netviewdm1", 729 /*     IBM NetView DM/6000 Server/Client */ }, 
    { "netviewdm2", 730 /*     IBM NetView DM/6000 send/tcp */ },
    { "netviewdm3", 731 /*     IBM NetView DM/6000 receive/tcp */ }, 
    { "netgw", 741 /*     netGW */ }, 
    { "netrcs", 742 /*     Network based Rev. Cont. Sys. */ }, 
    { "flexlm", 744 /*     Flexible License Manager */ }, 
    { "fujitsu-dev", 747 /*     Fujitsu Device Control */ }, 
    { "ris-cm", 748 /*     Russell Info Sci Calendar Manager */ },
    { "kerberos-adm", 749 /*     kerberos administration */ }, 
    { "rfile", 750 /*  */ }, 
    { "pump", 751 /*  */ }, 
    { "qrh", 752 /*  */ }, 
    { "rrh", 753 /*  */ }, 
    { "tell", 754 /*      send */ }, 
    { "nlogin", 758 /*  */ }, 
    { "con", 759 /*  */ }, 
    { "ns", 760 /*  */ }, 
    { "rxe", 761 /*  */ }, 
    { "quotad", 762 /*  */ }, 
    { "cycleserv", 763 /*  */ }, 
    { "omserv", 764 /*  */ }, 
    { "webster", 765 /*  */ }, 
    { "phonebook", 767 /*     phone */ }, 
    { "vid", 769 /*  */ }, 
    { "cadlock", 770 /*  */ }, 
    { "rtip", 771 /*  */ },
    { "cycleserv2", 772 /*  */ }, 
    { "submit", 773 /*  */ }, 
    { "rpasswd", 774 /*  */ }, 
    { "entomb", 775 /*  */ }, 
    { "wpages", 776 /*  */ }, 
    { "wpgs", 780 /*  */ }, 
    { "concert", 786 /*        Concert */ }, 
    { "mdbs_daemon", 800 /*  */ }, 
    { "device", 801 /*  */ }, 
    { "xtreelic", 996 /*         Central Point Software */ }, 
    { "maitrd", 997 /*  */ }, 
    { "busboy", 998 /*  */ }, 
    { "garcon", 999 /*  */ },
    { "puprouter", 999 /*  */ }, 
    { "cadlock", 1000 /* p */ }, 
    { "blackjack", 1025 /* p   network blackjack */ }, 
    { "iad1", 1030 /* p   BBN IAD */ }, 
    { "iad2", 1031 /* p   BBN IAD */ }, 
    { "iad3", 1032 /* p   BBN IAD */ },
    { "instl_boots", 1067 /* p   Installation Bootstrap Proto. Serv. */ }, 
    { "instl_bootc", 1068 /* p   Installation Bootstrap Proto. Cli. */ }, 
    { "socks", 1080 /* p   Socks */ }, 
    { "ansoft-lm-1", 1083 /* p   Anasoft License Manager */ }, 
    { "ansoft-lm-2", 1084 /* p   Anasoft License Manager */ }, 
    { "nfa", 1155 /* p   Network File Access */ }, 
    { "nerv", 1222 /* p   SNI R&D network */ }, 
    { "hermes", 1248 /* p */ }, 
    { "alta-ana-lm", 1346 /* p   Alta Analytics License Manager */ }, 
    { "bbn-mmc", 1347 /* p   multi media conferencing */ }, 
    { "bbn-mmx", 1348 /* p   multi media conferencing */ }, 
    { "sbook", 1349 /* p   Registration Network Protocol */ }, 
    { "editbench", 1350 /* p   Registration Network Protocol */ }, 
    { "equationbuilder", 1351 /* p   Digital Tool Works (MIT) */ }, 
    { "lotusnote", 1352 /* p   Lotus Note */ }, 
    { "relief", 1353 /* p   Relief Consulting */ }, 
    { "rightbrain", 1354 /* p   RightBrain Software */ }, 
    { "cuillamartin", 1356 /* p   CuillaMartin Company */ },
    { "pegboard", 1357 /* p   Electronic PegBoard */ }, 
    { "connlcli", 1358 /* p   CONNLCLI */ }, 
    { "ftsrv", 1359 /* p   FTSRV */ }, 
    { "mimer", 1360 /* p   MIMER */ }, 
    { "linx", 1361 /* p   LinX */ }, 
    { "timeflies", 1362 /* p   TimeFlies */ }, 
    { "ndm-requester", 1363 /* p   Network DataMover Requester */ }, 
    { "ndm-server", 1364 /* p   Network DataMover Server */ }, 
    { "adapt-sna", 1365 /* p   Network Software Associates */ }, 
    { "netware-csp", 1366 /* p   Novell NetWare Comm Service Platform */ }, 
    { "dcs", 1367 /* p   DCS */ }, 
    { "screencast", 1368 /* p   ScreenCast */ }, 
    { "gv-us", 1369 /* p   GlobalView to Unix Shell */ },
    { "us-gv", 1370 /* p   Unix Shell to GlobalView */ }, 
    { "fc-cli", 1371 /* p   Fujitsu Config Protocol */ }, 
    { "fc-ser", 1372 /* p   Fujitsu Config Protocol */ }, 
    { "chromagrafx", 1373 /* p   Chromagrafx */ }, 
    { "molly", 1374 /* p   EPI Software Systems */ }, 
    { "bytex", 1375 /* p   Bytex */ },
    { "ibm-pps", 1376 /* p   IBM Person to Person Software */ }, 
    { "cichlid", 1377 /* p   Cichlid License Manager */ }, 
    { "elan", 1378 /* p   Elan License Manager */ }, 
    { "dbreporter", 1379 /* p   Integrity Solutions */ }, 
    { "telesis-licman", 1380 /* p   Telesis Network License Manager */ }, 
    { "apple-licman", 1381 /* p   Apple Network License Manager */ }, 
    { "udt_os", 1382 /* p */ }, 
    { "gwha", 1383 /* p   GW Hannaway Network License Manager */ }, 
    { "os-licman", 1384 /* p   Objective Solutions License Manager */ }, 
    { "atex_elmd", 1385 /* p   Atex Publishing License Manager */ }, 
    { "checksum", 1386 /* p   CheckSum License Manager */ }, 
    { "cadsi-lm", 1387 /* p   Computer Aided Design Software Inc LM */ }, 
    { "objective-dbc", 1388 /* p   Objective Solutions DataBase Cache */ }, 
    { "iclpv-dm", 1389 /* p   Document Manager */ }, 
    { "iclpv-sc", 1390 /* p   Storage Controller */ }, 
    { "iclpv-sas", 1391 /* p   Storage Access Server */ }, 
    { "iclpv-pm", 1392 /* p   Print Manager */ }, 
    { "iclpv-nls", 1393 /* p   Network Log Server */ },
    { "iclpv-nlc", 1394 /* p   Network Log Client */ }, 
    { "iclpv-wsm", 1395 /* p   PC Workstation Manager software */ }, 
    { "dvl-activemail", 1396 /* p   DVL Active Mail */ }, 
    { "audio-activmail", 1397 /* p   Audio Active Mail */ }, 
    { "video-activmail", 1398 /* p   Video Active Mail */ }, 
    { "cadkey-licman", 1399 /* p   Cadkey License Manager */ }, 
    { "cadkey-tablet", 1400 /* p   Cadkey Tablet Daemon */ }, 
    { "goldleaf-licman", 1401 /* p   Goldleaf License Manager */ }, 
    { "prm-sm-np", 1402 /* p   Prospero Resource Manager */ }, 
    { "prm-nm-np", 1403 /* p   Prospero Resource Manager */ }, 
    { "igi-lm", 1404 /* p   Infinite Graphics License Manager */ }, 
    { "ibm-res", 1405 /* p   IBM Remote Execution Starter */ }, 
    { "netlabs-lm", 1406 /* p   NetLabs License Manager */ },
    { "dbsa-lm", 1407 /* p   DBSA License Manager */ }, 
    { "sophia-lm", 1408 /* p   Sophia License Manager */ }, 
    { "here-lm", 1409 /* p   Here License Manager */ }, 
    { "hiq", 1410 /* p   HiQ License Manager */ }, 
    { "af", 1411 /* p   AudioFile */ }, 
    { "innosys", 1412 /* p   InnoSys */ },
    { "innosys-acl", 1413 /* p   Innosys-ACL */ }, 
    { "ibm-mqseries", 1414 /* p   IBM MQSeries */ }, 
    { "dbstar", 1415 /* p   DBStar */ }, 
    { "novell-lu6.2", 1416 /* p   Novell LU6.2 */ }, 
    { "timbuktu-srv1", 1417 /* p   Timbuktu Service 1 Port */ }, 
    { "timbuktu-srv1", 1417 /* p   Timbuktu Service 1 Port */ }, 
    { "timbuktu-srv2", 1418 /* p   Timbuktu Service 2 Port */ }, 
    { "timbuktu-srv3", 1419 /* p   Timbuktu Service 3 Port */ }, 
    { "timbuktu-srv4", 1420 /* p   Timbuktu Service 4 Port */ }, 
    { "gandalf-lm", 1421 /* p   Gandalf License Manager */ }, 
    { "autodesk-lm", 1422 /* p   Autodesk License Manager */ }, 
    { "essbase", 1423 /* p   Essbase Arbor Software */ }, 
    { "hybrid", 1424 /* p   Hybrid Encryption Protocol */ }, 
    { "zion-lm", 1425 /* p   Zion Software License Manager */ }, 
    { "sas-1", 1426 /* p   Satellite-data Acquisition System 1 */ }, 
    { "mloadd", 1427 /* p   mloadd monitoring tool */ }, 
    { "informatik-lm", 1428 /* p   Informatik License Manager */ }, 
    { "nms", 1429 /* p   Hypercom NMS */ },
    { "tpdu", 1430 /* p   Hypercom TPDU */ }, 
    { "rgtp", 1431 /* p   Reverse Gosip Transport */ }, 
    { "blueberry-lm", 1432 /* p   Blueberry Software License Manager */ }, 
    { "ms-sql-s", 1433 /* p   Microsoft-SQL-Server */ }, 
    { "ms-sql-m", 1434 /* p   Microsoft-SQL-Monitor */ }, 
    { "ibm-cics", 1435 /* p   IBM CISC */ }, 
    { "sas-2", 1436 /* p   Satellite-data Acquisition System 2 */ }, 
    { "tabula", 1437 /* p   Tabula */ }, 
    { "eicon-server", 1438 /* p   Eicon Security Agent/Server */ }, 
    { "eicon-x25", 1439 /* p   Eicon X25/SNA Gateway */ }, 
    { "eicon-slp", 1440 /* p   Eicon Service Location Protocol */ }, 
    { "cadis-1", 1441 /* p   Cadis License Management */ }, 
    { "cadis-2", 1442 /* p   Cadis License Management */ },
    { "ies-lm", 1443 /* p   Integrated Engineering Software */ }, 
    { "marcam-lm", 1444 /* p   Marcam  License Management */ }, 
    { "proxima-lm", 1445 /* p   Proxima License Manager */ }, 
    { "ora-lm", 1446 /* p   Optical Research Associates License Manager */ }, 
    { "apri-lm", 1447 /* p   Applied Parallel Research LM */ }, 
    { "oc-lm", 1448 /* p   OpenConnect License Manager */ },
    { "peport", 1449 /* p   PEport */ }, 
    { "dwf", 1450 /* p   Tandem Distributed Workbench Facility */ }, 
    { "infoman", 1451 /* p   IBM Information Management */ }, 
    { "gtegsc-lm", 1452 /* p   GTE Government Systems License Man */ }, 
    { "genie-lm", 1453 /* p   Genie License Manager */ }, 
    { "interhdl_elmd", 1454 /* p   interHDL License Manager */ }, 
    { "interhdl_elmd", 1454 /* p   interHDL License Manager */ }, 
    { "esl-lm", 1455 /* p   ESL License Manager */ }, 
    { "dca", 1456 /* p   DCA */ }, 
    { "valisys-lm", 1457 /* p    Valisys License Manager */ }, 
    { "nrcabq-lm", 1458 /* p    Nichols Research Corp. */ }, 
    { "proshare1", 1459 /* p    Proshare Notebook Application */ }, 
    { "proshare2", 1460 /* p    Proshare Notebook Application */ }, 
    { "ibm_wrless_lan", 1461 /* p    IBM Wireless LAN */ }, 
    { "world-lm", 1462 /* p    World License Manager */ }, 
    { "nucleus", 1463 /* p    Nucleus */ }, 
    { "msl_lmd", 1464 /* p    MSL License Manager */ }, 
    { "pipes", 1465 /* p    Pipes Platform */ },
    { "oceansoft-lm", 1466 /* p    Ocean Software License Manager */ }, 
    { "csdmbase", 1467 /* p    CSDMBASE */ }, 
    { "csdm", 1468 /* p    CSDM */ }, 
    { "aal-lm", 1469 /* p    Active Analysis Limited License Manager */ }, 
    { "uaiact", 1470 /* p    Universal Analytics */ }, 
    { "csdmbase", 1471 /* p    csdmbase */ }, 
    { "csdm", 1472 /* p    csdm */ }, 
    { "openmath", 1473 /* p    OpenMath */ }, 
    { "telefinder", 1474 /* p    Telefinder */ }, 
    { "taligent-lm", 1475 /* p    Taligent License Manager */ }, 
    { "clvm-cfg", 1476 /* p    clvm-cfg */ }, 
    { "ms-sna-server", 1477 /* p    ms-sna-server */ }, 
    { "ms-sna-base", 1478 /* p    ms-sna-base */ },
    { "dberegister", 1479 /* p    dberegister */ }, 
    { "pacerforum", 1480 /* p    PacerForum */ }, 
    { "airs", 1481 /* p    AIRS */ }, 
    { "miteksys-lm", 1482 /* p    Miteksys License Manager */ }, 
    { "afs", 1483 /* p    AFS License Manager */ }, 
    { "confluent", 1484 /* p    Confluent License Manager */ },
    { "lansource", 1485 /* p    LANSource */ }, 
    { "nms_topo_serv", 1486 /* p    nms_topo_serv */ }, 
    { "localinfosrvr", 1487 /* p    LocalInfoSrvr */ }, 
    { "docstor", 1488 /* p    DocStor */ }, 
    { "dmdocbroker", 1489 /* p    dmdocbroker */ }, 
    { "insitu-conf", 1490 /* p    insitu-conf */ }, 
    { "anynetgateway", 1491 /* p    anynetgateway */ }, 
    { "stone-design-1", 1492 /* p    stone-design-1 */ }, 
    { "netmap_lm", 1493 /* p    netmap_lm */ }, 
    { "ica", 1494 /* p    ica */ }, 
    { "cvc", 1495 /* p    cvc */ }, 
    { "liberty-lm", 1496 /* p    liberty-lm */ }, 
    { "rfx-lm", 1497 /* p    rfx-lm */ }, 
    { "watcom-sql", 1498 /* p    Watcom-SQL */ }, 
    { "fhc", 1499 /* p    Federico Heinz Consultora */ }, 
    { "vlsi-lm", 1500 /* p    VLSI License Manager */ }, 
    { "sas-3", 1501 /* p    Satellite-data Acquisition System 3 */ }, 
    { "shivadiscovery", 1502 /* p    Shiva */ },
    { "imtc-mcs", 1503 /* p    Databeam */ }, 
    { "evb-elm", 1504 /* p    EVB Software Engineering License Manager */ }, 
    { "funkproxy", 1505 /* p    Funk Software, Inc. */ }, 
    { "ingreslock", 1524 /* p    ingres */ }, 
    { "orasrv", 1525 /* p    oracle */ }, 
    { "prospero-np", 1525 /* p    Prospero Directory Service non-priv */ }, 
    { "pdap-np", 1526 /* p    Prospero Data Access Prot non-priv */ }, 
    { "tlisrv", 1527 /* p    oracle */ }, 
    { "coauthor", 1529 /* p    oracle */ }, 
    { "issd", 1600 /* p */ }, 
    { "nkd", 1650 /* p */ }, 
    { "proshareaudio", 1651 /* p   proshare conf audio */ }, 
    { "prosharevideo", 1652 /* p   proshare conf video */ },
    { "prosharedata", 1653 /* p   proshare conf data */ }, 
    { "prosharerequest", 1654 /* p   proshare conf request */ }, 
    { "prosharenotify", 1655 /* p   proshare conf notify */ }, 
    { "netview-aix-1", 1661 /* p   netview-aix-1 */ }, 
    { "netview-aix-2", 1662 /* p   netview-aix-2 */ }, 
    { "netview-aix-3", 1663 /* p   netview-aix-3 */ },
    { "netview-aix-4", 1664 /* p   netview-aix-4 */ }, 
    { "netview-aix-5", 1665 /* p   netview-aix-5 */ }, 
    { "netview-aix-6", 1666 /* p   netview-aix-6 */ }, 
    { "licensedaemon", 1986 /* p   cisco license management */ }, 
    { "tr-rsrb-p1", 1987 /* p   cisco RSRB Priority 1 port */ }, 
    { "tr-rsrb-p2", 1988 /* p   cisco RSRB Priority 2 port */ }, 
    { "tr-rsrb-p3", 1989 /* p   cisco RSRB Priority 3 port */ }, 
    { "mshnet", 1989 /* p   MHSnet system */ }, 
    { "stun-p1", 1990 /* p   cisco STUN Priority 1 port */ }, 
    { "stun-p2", 1991 /* p   cisco STUN Priority 2 port */ }, 
    { "stun-p3", 1992 /* p   cisco STUN Priority 3 port */ }, 
    { "ipsendmsg", 1992 /* p   IPsendmsg */ }, 
    { "snmp-tcp-port", 1993 /* p   cisco SNMP TCP port */ }, 
    { "stun-port", 1994 /* p   cisco serial tunnel port */ }, 
    { "perf-port", 1995 /* p   cisco perf port */ }, 
    { "tr-rsrb-port", 1996 /* p   cisco Remote SRB port */ }, 
    { "gdp-port", 1997 /* p   cisco Gateway Discovery Protocol */ }, 
    { "x25-svc-port", 1998 /* p   cisco X.25 service (XOT) */ },
    { "tcp-id-port", 1999 /* p   cisco identification port */ }, 
    { "callbook", 2000 /* p */ }, 
    { "dc", 2001 /* p */ }, 
    { "globe", 2002 /* p */ }, 
    { "mailbox", 2004 /* p */ }, 
    { "berknet", 2005 /* p */ }, 
    { "invokator", 2006 /* p */ }, 
    { "dectalk", 2007 /* p */ }, 
    { "conf", 2008 /* p */ }, 
    { "news", 2009 /* p */ }, 
    { "search", 2010 /* p */ }, 
    { "raid-cc", 2011 /* p    raid */ }, 
    { "ttyinfo", 2012 /* p */ },
    { "raid-am", 2013 /* p */ }, 
    { "troff", 2014 /* p */ }, 
    { "cypress", 2015 /* p */ }, 
    { "bootserver", 2016 /* p */ }, 
    { "cypress-stat", 2017 /* p */ }, 
    { "terminaldb", 2018 /* p */ },
    { "whosockami", 2019 /* p */ }, 
    { "xinupageserver", 2020 /* p */ }, 
    { "servexec", 2021 /* p */ }, 
    { "down", 2022 /* p */ }, 
    { "xinuexpansion3", 2023 /* p */ }, 
    { "xinuexpansion4", 2024 /* p */ }, 
    { "ellpack", 2025 /* p */ }, 
    { "scrabble", 2026 /* p */ }, 
    { "shadowserver", 2027 /* p */ }, 
    { "submitserver", 2028 /* p */ }, 
    { "device2", 2030 /* p */ }, 
    { "blackboard", 2032 /* p */ }, 
    { "glogger", 2033 /* p */ }, 
    { "scoremgr", 2034 /* p */ }, 
    { "imsldoc", 2035 /* p */ }, 
    { "objectmanager", 2038 /* p */ }, 
    { "lam", 2040 /* p */ }, 
    { "interbase", 2041 /* p */ },
    { "isis", 2042 /* p */ }, 
    { "isis-bcast", 2043 /* p */ }, 
    { "rimsl", 2044 /* p */ }, 
    { "cdfunc", 2045 /* p */ }, 
    { "sdfunc", 2046 /* p */ }, 
    { "dls", 2047 /* p */ }, 
    { "dls-monitor", 2048 /* p */ }, 
    { "shilp", 2049 /* p */ }, 
    { "dlsrpn", 2065 /* p   Data Link Switch Read Port Number */ }, 
    { "dlswpn", 2067 /* p   Data Link Switch Write Port Number */ }, 
    { "ats", 2201 /* p   Advanced Training System Program */ }, 
    { "rtsserv", 2500 /* p   Resource Tracking system server */ }, 
    { "rtsclient", 2501 /* p   Resource Tracking system client */ },
    { "hp-3000-telnet", 2564 /* p   HP 3000 NS/VT block mode telnet */ }, 
    { "www-dev", 2784 /* p   world wide web - development */ }, 
    { "NSWS", 3049 /* p */ }, 
    { "ccmail", 3264 /* p   cc:mail/lotus */ }, 
    { "dec-notes", 3333 /* p   DEC Notes */ }, 
    { "mapper-nodemgr", 3984 /* tcp     MAPPER network node manager */ },
    { "mapper-mapethd", 3985 /* tcp     MAPPER TCP/IP server */ }, 
    { "mapper-ws_ethd", 3986 /* tcp     MAPPER workstation server */ }, 
    { "bmap", 3421 /* p   Bull Apprise portmapper */ }, 
    { "udt_os", 3900 /* p   Unidata UDT OS */ }, 
    { "nuts_dem", 4132 /* p   NUTS Daemon */ }, 
    { "nuts_bootp", 4133 /* p   NUTS Bootp Server */ }, 
    { "unicall", 4343 /* p   UNICALL */ }, 
    { "krb524", 4444 /* p   KRB524 */ }, 
    { "rfa", 4672 /* p   remote file access server */ }, 
    { "commplex-main", 5000 /* p */ }, 
    { "commplex-link", 5001 /* p */ }, 
    { "rfe", 5002 /* p   radio free ethernet */ }, 
    { "telelpathstart", 5010 /* p   TelepathStart */ }, 
    { "telelpathattack", 5011 /* p   TelepathAttack */ }, 
    { "mmcc", 5050 /* p   multimedia conference control tool */ }, 
    { "rmonitor_secure", 5145 /* p */ }, 
    { "aol", 5190 /* p   America-Online */ }, 
    { "padl2sim", 5236 /* p */ },
    { "hacl-hb", 5300 /* p        # HA cluster heartbeat */ }, 
    { "hacl-gs", 5301 /* p        # HA cluster general services */ }, 
    { "hacl-cfg", 5302 /* p        # HA cluster configuration */ }, 
    { "hacl-probe", 5303 /* p        # HA cluster probing */ }, 
    { "hacl-local", 5304 /* p */ }, 
    { "hacl-test", 5305 /* p */ },
    { "x11", 6000 /* 63/tcp   X Window System */ },
    { "x11", 6001 /* 63/tcp   X Window System */ },
    { "x11", 6002 /* 63/tcp   X Window System */ },
    { "x11", 6003 /* 63/tcp   X Window System */ },
    { "sub-process", 6111 /* p   HP SoftBench Sub-Process Control */ }, 
    { "meta-corp", 6141 /* p   Meta Corporation License Manager */ }, 
    { "aspentec-lm", 6142 /* p   Aspen Technology License Manager */ }, 
    { "watershed-lm", 6143 /* p   Watershed License Manager */ }, 
    { "statsci1-lm", 6144 /* p   StatSci License Manager - 1 */ }, 
    { "statsci2-lm", 6145 /* p   StatSci License Manager - 2 */ },
    { "lonewolf-lm", 6146 /* p   Lone Wolf Systems License Manager */ },
    { "montage-lm", 6147 /* p   Montage License Manager */ },
    { "xdsxdm", 6558 /* p */ },
    { "afs3-fileserver", 7000 /* p   file server itself */ },
    { "afs3-callback", 7001 /* p   callbacks to cache managers */ },
    { "afs3-prserver", 7002 /* p   users & groups database */ },
    { "afs3-vlserver", 7003 /* p   volume location database */ },
    { "afs3-kaserver", 7004 /* p   AFS/Kerberos authentication service */ },
    { "afs3-volser", 7005 /* p   volume managment server */ },
    { "afs3-errors", 7006 /* p   error interpretation service */ },
    { "afs3-bos", 7007 /* p   basic overseer process */ },
    { "afs3-update", 7008 /* p   server-to-server updater */ },
    { "afs3-rmtsys", 7009 /* p   remote cache manager service */ },
    { "ups-onlinet", 7010 /* p   onlinet uninterruptable power supplies */ },
    { "font-service", 7100 /* p   X Font Service */ },
    { "fodms", 7200 /* p   FODMS FLIP */ },
    { "man", 9535 /* p */ },
    { "isode-dua", 17007 /* cp */ },
};

void AssPort::FillString(TStringList*& pList, bool tcp)
{
    SAssPort* pEntry = (tcp) ? tcpPort : udpPort;
    int max = (tcp) ? COUNTOF(tcpPort) : COUNTOF(udpPort);
    pList = new TStringList;
    for (int i = 0; i < max; i++, pEntry++)
    {
        char sz[64];
        wsprintf(sz, "%-16s%d", pEntry->ServiceName, pEntry->Port);
        pList->AddObject(sz, reinterpret_cast<TObject*>(pEntry->Port));
    }
}

const char* AssPort::SearchPort(int port, bool tcp)
{
    SAssPort* pEntry = (tcp) ? tcpPort : udpPort;
    int r = (tcp) ? COUNTOF(tcpPort) : COUNTOF(udpPort);
    r--;
    int l = 0;
    int m;
    while (l < r)
    {
        m = (l + r) / 2;
        if ((pEntry + m)->Port == port)
            return (pEntry + m)->ServiceName;
        else if ((pEntry + m)->Port < port)
            l = m + 1;
        else
            r = m;
    }
    if ((pEntry + l)->Port == port)
        return (pEntry + l)->ServiceName;
    return NULL;
}

const char* AssPort::SearchTCPPort(int port)
{
    return SearchPort(port, true);
}

const char* AssPort::SearchUDPPort(int port)
{
    return SearchPort(port, false);
}

